Startpage

WinKFPT

Online help

Version 2.0

© Copyright by BMW AG, 1997-2012, created by Softing AG


Using this User's Guide and the Online Help

The User's Guide and the online help are identical. Whenever updates of WinKFPT are released, the User's Guide and online help will be updated at the same time.

Publication and distribution of the User's Guide are the responsibility of BMW


About This User's Guide

This User's Guide has been divided into the following chapters:

Chapter | Description
INTRODUCTION IDH_ueber_winkfpt | Brief description, intended use, operating modes, programming possibilities and architecture of WinKFPT.
First Steps IDH_systemanforderungen_des_winkfpt | System requirements, installation, list structure and configuration of WinKFPT.
Starting WinKFPT IDH_start_des_winkfpt | Description of the calling parameters and starting the various operating modes of WinKFPT. Description of the flash sequence in Batch mode.
WinKFPT's Main Menu IDH_hauptmenue_des_winkfpt | The following chapters describe how to use WinKFPT in Dialog mode. Menu options of the main menu bar of WinKFPT and their submenus
Functions of WinKFPT IDH_funktionen_des_winkfpt | Activating Comfort mode IDH_komfort_modus and Expert mode IDH_experten_modus.
Function Phases in Comfort Mode IDH_funktionsebenen_im_komfort_modus | Control functions in Comfort mode IDH_komfort_modus for flash programming a control unit.
Function Phases in Expert Mode IDH_funktionsebenen_im_experten_modus | Control functions in Expert mode IDH_experten_modus for flash programming a control unit.
General Functions IDH_allgemeine_funktionen | Special and diagnostics functions
Error Handling in WinKFPT IDH_fehlerbehandlung_im_winkfpt | Known control and configuration errors


Conventions Used

This User's Guide uses the following typographical conventions:

Example | Description
DEFAULT.INI | Names written in uppercase letters and italics denote file names.
"Import file sets" | Names written in italics and set in quotation marks denote a window or dialog box in the program.
12345 | Names written in italics but not set in quotation marks denote entries in input and/or display fields.
“OK“ | Names written in bold type and set in quotation marks denote buttons, radio buttons, check boxes, input fields or display fields.
<<ECU not responding>> | Words set in double angle brackets denote messages displayed to the user.
<Configuration> | Words underscored and set in single angle brackets denote main-menu and submenu options.
"Operating modes" | Words underscored and set in quotation marks denote chapter titles.


INTRODUCTION


About WinKFPT

WinKFPT is a program for flash programming (program and data) electronic control units (ECUs) used in the automotive industry.

WinKFPT was originally conceived purely as a reference tool for verifying the programmability of control units in the course of program and data programming.

Thanks to continuous expansion of its functionality, WinKFPT is now used as a development tool for suppliers of BMW who are involved in the development of control units.

The possibilities opened up by the Batch mode and the multiple instancing capability of WinKFPT have in the meantime enabled the range of application of the program to be expanded to cover production and service.

WinKFPT is the first tool that uses the COAPI functions for a boot sector update (BSU), and therefore facilitates ECU updates (exchange of boot sectors, programs, data) that go beyond the boundaries of ECU families. This reduces the need to exchange control units in e.g. the Service Department.

As of Version 4.6.0, WinKFPT uses the import/export functionality of the COAPI to manage development and tool-relevant data, ECU-specific and general logistics files and assembly line data sets for saving and loading development configurations in order to improve error tracing during development and flash verification of the control units.


Possibilities in WinKFPT


Multiple Instancing Capability

To shorten programming times by means of parallel programming of several control units via various HW interfaces or diagnosis channels, it is possible to call a separate WinKFPT instance for each HW interface connected that can be initialized via the EDIABAS interface.


Operating Modes

WinKFPT has two main operating modes

1. Dialog mode

2. Batch mode

and one special operating mode

3. Compile mode.

The table below contains a brief description of each of WinKFPT's operating modes.

Operating mode

Description

Dialog mode

= Standard operating mode – all ECU flash programming entries are made by the user in Dialog mode.

Batch mode

Can be started from Dialog mode or by being called with appropriate calling parameters.

The programming of ECUs is configured and started by means of specific control files.

Compile mode

This operating mode is started by means of a special calling parameter and is used only to translate a PABD in source code (xxx.ips).

The object code file (xxx.ipo) of the PABD is then located following translation as a resident file in the PABD directory "<root>\sgdat".

Table: Operating modes of WinKFPT


Programming of ECUs in Dialog Mode

There are three possibilities for flash programming a control unit using the Dialog mode of WinKFPT.

The two possibilities in Comfort Mode IDH_komfort_modus:

1. Entry or selection of the assembly identification number (ZUSB No.), selection of any number of integration positions offered for the ZUSB No., entry of the vehicle identification number (VIN) when a UIF is written, and subsequent flash programming of the control unit or control units in Comfort mode.

2. Selection of a control unit family and of any number of integration positions offered for this family, and subsequent updating of the control unit or control units in Comfort mode to the latest assembly identification within the respective series of compatible hardware releases. If a transition between non-compatible hardware releases is possible by means of a boot sector update, updating of the assembly identification code goes beyond just changing the hardware, actually potentially involving changing the ECU family.

One possibility in Expert Mode IDH_experten_modus:

3. Selection of the necessary PABDs, P-SGBDs and data set names and subsequent flash programming of the control unit in Expert mode.

In addition to be able to flash program control units, a number of special and diagnostics functions, such as "Read UIF" or "ECU Status" are supported.


Programming of ECUs in Batch Mode

Batch mode is used to flash program any number of control units one after the other.

WinKFPT can be started from an external application in Batch mode; in this case, flash programming of the control units is initiated by means of a control file.


Architecture of WinKFPT

The following diagram shows the architecture of communication between two WinKFPT instances that have been called from an external application:

Fig.: Communication architecture in WinKFPT


First Steps


System Requirements of WinKFPT

To be able to flash program control units with WinKFPT, the system requirements listed in the table below must be met:

Requirement | Remark
Computer | PENTIUM II processor or higher with 64 MB RAM and 50 MB of free memory
Operating system | MS-Windows NT Version 4.0 or MS-Windows XP
Built-in diagnosis interface | ADS, ADS-OBD, EDICcard, EDICcard2, EDICcardC, CANcard, CAN / Vector, Most / Optolyzer, Most / PC card or InfraRed / MDA
Built-in EDIABAS interface | Version 6.0.2 or higher
Control unit | Programmable

Table: System Requirements of WinKFPT


Installing WinKFPT

WinKFPT is installed by starting WINKFPT32.EXE from the installation CD or disk.

You are prompted to enter the target directory (<root>) in which the software is to be installed.

At the end of the installation routine, a link to the program is created on the desktop and a program group for UNINSTALL also created.

In Version 1.4 and higher, all configuration files required are available in rudimentary form following installation, so that WinKFPT will run up without any problem.

You can then import the assembly line data (Comfort Mode IDH_komfort_modus) or PABD and P-SGBD files and data sets and program data sets (Expert modeIDH_experten_modus) you want online using the import functionality of WinKFPT (see "5.2 Import/Export MenuIDH_menue_import_export").


Directory Structure of WinKFPT

WinKFPT is installed in the directory you specify during installation.

The installation directory <root> contains the following subdirectories:

· \<root>\BIN

· \<root>\CFGDAT

· \<root>\DATA

· \<root>\FORMAT

· \<root>\SGDAT

· \<root>\WORK

The installation directory contains two files you will need if you want to uninstall WinKFPT at some point in the future:

· INSTALL.LOG, the file containing the uninstall information

· UNWISE.EXE, the WinKFPT uninstaller.

Directory

Contents

\<root>\BIN

This directory contains all necessary program files (EXE, DLL) and the initialization/configuration file WINKFPT.INI.

It also serves as a working directory for storing error files and other temporary files created while the program is running (e.g. INNENTMP_INTERFACE_unit.OUT).

CABIGER.DLL

Coding sequence interpreter – localization support DLL (German)

CABUS.DLL

Coding sequence interpreter – localization support DLL (English)

WINKFPT.INI

Configuration file for WinKFPT

WINKFPT32.EXE

Executable for WinKFPT

WINKFPT32.HLP

Online help for WinKFPT

ERROR_INTERFACE_unit.LOG

As of Version 4.6.0, the installation directory is only the default directory for storing error files.

You can select/set any directory you want as the storage directory by means of the main menu option <Configuration>.

Error file.

Every error file refers to an instance of WinKFPT.

The file name incorporates the HW interface identifier and unit identifier to enable assignment to the relevant instance.

INTERFACE

HW interface identifier

_unit

Unit identifier (_, A, B, C, ...)

*.OUT

Temporary files created during program run

\<root>\CFGDAT

Directory contains the initialization files:

INPA.INI

Initialization file for the coding sequence interpreter.

The contents of this file are laid down at the time of delivery of WinKFPT and are not allowed to be used by the user.

For further information, see system description of the COAPI.

COAPI.INI

Configuration for the coding application interface

Directory also contains the text files for error messages:

COAPIERR.TXT

Text file for COAPI error messages

EDIERROR.TXT

Text file for EDIABAS error messages

\<root>\DATA\DEVELOP

Directory contains the programming data files available in Expert modeIDH_experten_modus.

*.PAF

Program exchange files

*.DAF

Data exchange files

*.BAF

NAAB exchange files

*.0PA

Data set files for program

*.0DA

Data set files for data

*.0BA

Data set files for NAAB

\<root>\DATA\GDATEN

Directory contains the logistics files for ECU flash programming. These must always be available. The files are loaded by importing an assembly line data set:

KFCONFxx.DA2

Contains all ECU members and the associated names of the description and ECU-specific logistics files and a data set identifier for each of these ECU members.

As of Version 4.6.0, only those ECU members of the imported, valid WDPs are contained.

SWTCONFx.DAT

Contains data for Sweeping Technologies

HWNR.DA2

Contains all the hardware numbers every assigned for all ECUs

As of Version 4.6.0, only those hardware numbers for ECU families of the imported, valid WDPs are contained.

NPV.DAT

Logistics file for retrofit actions in the HO. Of no relevance to WinKFPT.

Special configuration files that must be present if required:

INFO.GER

Contains the integration position of an ECU member in plain text for user selection in WinKFPT, e.g. "Passenger side, rear".

In general, these integration position texts only exist for ECUs that have different ECU members, i.e. integration position, but belong to the same ECU family.

<Optional> Only for Comfort modeIDH_komfort_modus for selection of the integration position (= implicit input of the ECU address when the same control unit type is installed more than once in the same car)

PRGIFSEL.DAT

Contains variable assignments of ECU family to HW interface and diagnosis protocol.

<Optional> Only for Batch mode for flash programming several control units one after the other.

SGIDC.AS2

Contains the authentication codes of all ECUs for authentication level "3".

<Optional> Only for control units with authentication.

SGIDD.AS2

Contains the authentication codes of all ECUs for authentication level "4".

<Optional> Only for control units with authentication.

HISTORIE.BSU

Contains the necessary specifications for determining whether a boot sector update is possible for all control units affected.

<Optional> Facilitates a boot sector update for certain control units.

\<root>\DATA\<SgFam>

Each of these directories contains the ASCII programming data for an ECU family <EcuFam>. These directories are used in Comfort mode.

Note: all the logistics files of an ECU family must be present in each case. These are:

<SgFam>.DAT

Contains all current assembly identification numbers of an ECU family.

<SgFam>.HIS

Contains all compatible assembly identification numbers ever assigned for an ECU family in one or more series.

<SgFam>.HWH

Contains the history of compatible hardware numbers of an ECU family in one or more series.

\<root>\DATA\KONV

Directory contains the compressed programming data in MoDiC/DIS format.

\<root>\DATA\KONV.TMP

Temporary directory for storing programming data files while WinKFPT is running through several instances:

\<root>\DATA\KONV.TMP2,

\<root>\DATA\KONV.TMP3 etc...

\<root\SGDAT

Directory contains the header files and PABDs in source code and/or in compiled code.

* . IPS

PABDs in source code

* . IPO

PABDs in compiled code

The source code of the flash sequence description files (PABDs) is available in the INPA script language.

Files can be available in source code or in compiled form; the compiled form is generated from the source code by means of the CABI compiler.

Since the functionality of the CABI compiler is integrated in the COAPI, WinKFPT can process both forms of a PABD.

\<root>\WORK

Working directory for COAPI and WinKFPT for storing trace and other temporary files.

The working directory can be changed by means of the COAPI.INI file. The working directory must be created because WinKFPT will otherwise not start.

Table: Directories and files of WinKFPT


Configuration of the basic directory

Configuration of the basic directory for the working directories of WinKFPT

By means of the main menu option "Configuration IDH_menue_konfiguration" the basic directory for the working directories can be changed at any time.

This means it is possible for several instances of WinKFPT to work with one central set of working directories placed anywhere in a network environment.

A new basic directory is only accepted if below there are all working directories containing the minimum set of files as they are provided after a first installation of WinKFPT.

Otherwise an error message occurs and the actual valid basic directory is not changed.

Note:

It is possible that existing programming settings are not valid any longer after a change of the working directories.


Configuring WinKFPT

WinKFPT is configured by means of the following initialization files:

Configuration file | Contents
COAPI.INI | Configuration for the coding application interface
WINKFPT.INI | Configuration for WinKFPT
EDIABAS.INI | Configuration for the diagnosis HW interface

Table: Initialization files of WinKFPT


Configuration in COAPI.INI

Die The initialization file "<root>IDH_footnote_root\CFGDAT\COAPI.INI" serves to configure directories, file names and system data for the COAPI core functions. The following sections and entries are of importance to WinKFPT:

Configuration entry

Possible setting

Default

Description

[Pfadangaben]

Paths for configuration files, data and trace files are set in this section.

WORKING_DIR

Complete path or relative to <root>IDH_footnote_root

<root>IDH_footnote_root\WORK

The entry specifies the directory that is used for COAPI trace files and for temporary files.

ERROR_TEXTE

Complete path or relative to <root>IDH_footnote_root

<root>IDH_footnote_root\CFGDAT

The entry specifies the directory in which the COAPI error text file is located.

GENERAL_KF_DATA_PATH

Complete path or relative to <root>IDH_footnote_root

<root>IDH_footnote_root\DATA

The entry specifies the directory in which the programming files are located.

[Kennfeldprog]

This section contains entries that are required specifically for engine characteristics map programming.

SERIENNUMMER

5-digit number

12345

The entry specifies the value that is entered as the serial number in the user info field.

KUNDENNUMMER

5-digit number

11111

The entry specifies the value that is entered as the customer number in the user info field.

KM

Max. 2-digit

number

0

The entry specifies the value that is entered as the mileage (in km) in the user info field.

ZBNUMMER IDH_footnote_expert_mit_aif

7-digit number

0000000

The entry specifies the value that is entered as the assembly identification number in the user info field.

SWNUMMER IDH_footnote_expert_mit_aif

7-digit number

0000000

The entry specifies the value that is entered as the software number in the user info field.

TYPNUMMER IDH_footnote_expert_mit_aif

7-digit number

0000000

The entry specifies the value that is entered as the type test number in the user info field.

AEINDEX IDH_footnote_expert_mit_aif

2-digit number

00

The entry specifies the value that is entered as the change index in the user info field.

[Setup]

In this section, you set which form of the PABD is to be displayed for selection in WinKFPT.

CabdFormat

IPS

IPO

COM

IPO

The entry defines whether the COAPI (as part of WinKFPT) is to use PABDs as source files or as compiled files. This entry is however irrelevant because it is cancelled by the corresponding entry in WinKfpt.ini or the setting in the Configuration dialog.

IPS PABDs as source

files

IPO PABDs as compiled

files

COM WinKFPT compiles

selected *.IPS files

and creates *.IPO

files. Compiling

is started when PABD

file is selected in

Expert mode.

BsuActive

ON

OFF

ON

The flag influences how the COAPI function behaves: coapiKfCheckBsuPossibleD2

When BsuActive=OFF, the function never returns the name of a NAAB files, i.e. a boot sector update cannot be executed, even if "historie.bsu" says it would be possible.

Setting of the default or of the flag in accordance with the configuration entry in "COAPI.INI" is performed in the COAPI function:

"coapiKfInit ()".

Table: Configuration in COAPI.INI


Configuration in WINKFPT.INI

The initialization file "<root>IDH_footnote_root\BIN\WINKFPT.INI" is used to configure characteristics of WinKFPT.

The following sections and entries are of importance to WinKFPT:

Configuration entry

Possible setting

Default

Description

[Einstellungen]

Paths for configuration files, data and trace files are set in this section.

WindowPosition

--

0,1,-1,-1,

-1,-1,0,0,

643,424

The entry saves the last window size of WinKFPT when the program is exited. The program then starts with the same coordinates when restarted.

SPRACHE

ger

eng

ger

The entry defines the language for WinKFPT. Options: German (ger) and English (eng).

U_PROG

ON

OFF

ON

The entry specifies whether the programming voltage is switched ON or OFF during flash programming.

SCHNELLE_BAUDRATE

ON

OFF

ON

The entry specifies whether the fast baudrate is used (ON) or not (OFF) during flash programming.

ANZEIGE_U_PROG

ON

OFF

ON

Der Eintrag gibt an, ob bei der Programmierung der Wert der Programmierspannung angezeigt wird (ON) oder nicht (OFF).

EXPERT_MIT_AIF

ON

OFF

ON

The entry specifies whether the UIF is also programmed (ON) or not (OFF) during flash programming in Expert modeIDH_experten_modus.

KOMFORT_MIT_AIF

ON

OFF

ON

The entry specifies whether the UIF is also programmed (ON) or not (OFF) during flash programming in Comfort modeIDH_komfort_modus.

AIF_SCHREIBEN_NACH_DATEN

ON

OFF

ON

The entry specifies whether the UIF is also programmed (ON) or not (OFF) during data programming in Comfort or Expert mode.

AIF_SCHREIBEN_NACH_PROGRAMM

ON

OFF

ON

The entry specifies whether the UIF is also programmed (ON) or not (OFF) during program programming in Comfort or Expert mode.

API_TRACE

0 – 7

OFF ( = 0)

ON ( = 1)

1

The entry specifies the trace level of the API traces of EDIABAS during flash programming. Trace level 0 means that no traces are generated.

IFH_TRACE

0 – 3

OFF ( = 0)

ON ( = 1)

1

The entry specifies the trace level of the IFH traces of EDIABAS during flash programming. Trace level 0 means that no traces are generated.

PROGRAMM_ERZWINGEN

ON

OFF

OFF

The entry specifies whether, during flash programming in Comfort mode, a program is also programmed when actually only data programming would be necessary.

TEST_CHECKSUMME

ON

OFF

ON

The entry specifies whether the checksum is validated (ON) or not (OFF) after programming of the data.

CabdFormat

IPS

IPO

(COM)

IPO

The entry defines whether WinKFPT is to use PABDs as source files or as compiled files.

IPS PABDs as source

files

IPO PABDs as compiled

files

COM stands for compile mode.

However, it does not

have to be set manually

in the Ini file, rather it

is set temporarily and

automatically by the

calling parameter "-C".

ErrorLogPath

any path

.\

Storage directory for the ERRORn.LOG file

ExpertKonfPath

any path

C:\

Diagprog

Base directory for export of a configuration of development files (Expert mode).

KomfortKonfPath

any path

C:\NFS-Backup

Base directory for export of a configuration of assembly line data (Comfort mode).

CoapiSearchPath

any path

..\

Base directory for working directories of WinKFPT

[HW-Interface]

In this section, those HW interfaces are entered that can be switched between online while WinKFPT is being used.

Interfaces are to be defined using the following syntax:

[Beschreibung] = [HW-Interface Bezeichner]

Beispiel:

K-Line / EDIC=EDIC

K-Line / ADS-OBD=STD:OBD

CAN / EDIC=EDICC

CAN / Vector=STD:CAN

Most / Optolyzer=STD:MOSTO

Most / PC-Karte=STD:MOSTP

You can select any string of letters for [Description].

The texts entered as the [Description] are displayed to the user in a HW interface selection list when the menu option Communication à HW Interface is selected, (e.g. K-Line / EDIC).

[HW interface identifier] is used internally in the WinKFPT program.

The identifier is defined and must be known to "EDIABAS" so that "EDIABAS" can also initialize the HW interface

[Expert-Modus-Konfiguration]

In this section, the current configuration in Expert mode is saved by the user (if necessary) when the program is exited. When the program is restarted and Expert mode reselected, the user is then able to reload this configuration.

KF_HW_INTERFACE

HW interface identifier

leer

Saved setting of the HW interface in Expert mode.

Interface can be selected by means of the menu option Communication à HW Interface.

KF_HW_INTERFACE_UNIT

_, A, B, C, D, E

leer

Saved setting of the HW interface unit in Expert mode.

Interface unit can be selected by means of the menu option Communication à HW Interface.

KF_DIAG_PROT

Identifier of the diagnosis protocol

leer

Saved setting of the diagnosis protocol in Expert mode; in the case of a P-SGBD file that supports several diagnosis protocols,

the diagnosis protocol can be selected by means of the menu option Communication à Diagnosis protocol.

KF_PSGBD

P-SGBD file name

leer

Saved setting of the P-SGBD file name in Expert mode.

P-SGBD file can be selected by pressing the function key Expert Mode à P-SGBD.

KF_PABD

PABD file name

leer

Saved setting of the PABD file name in Expert mode.

PABD file can be selected by pressing the function key Expert Mode à PABD.

KF_SG_ADR

ECU address

leer

Saved setting of the ECU address in Expert mode.

ECU address can be selected by pressing the function key Expert Mode à ECU Address.

KF_DATEN_DATEI

Data file

name

leer

Saved setting of the data set file for data in Expert mode.

Data set file for data can be selected by pressing the function key Expert Mode à Data File.

KF_PROGRAMM_DATEI

Program file

name

leer

Saved setting of the data set file for program in Expert mode.

Data set file for program can be selected by pressing

the function key Expert Mode à Program File.

KF_NAAB_DATEI

NAAB file

name

leer

Saved setting of the data set file for NAAB in Expert mode.

Data set file for NAAB can be selected by pressing

the function key Expert Mode à NAAB File.

N.B.: The entries in this section must be made by the user only in WinKFPT and not using Editor!

Table: Configuration in WINKFPT.INI

To save start information, WINKFPT.INI can, during the import and export of configurations, contain entries that are generated automatically by the program and that are not allowed to be changed or preset by the user.


Configuration for Expert Mode

The user has the option of saving and also of reloading a configuration in Expert Mode IDH_experten_modus if necessary.

A configuration is set in Expert mode by means of the free selection of the following job data and settings:

· HW interface and unit

· Diagnosis protocol

· P-SGBD

· PABD

· Control unit address

· Data file

· Program file

· BSU NAAB file

HW interface and unit is selected by means of the menu option Communication à HW Interface in Expert mode (see “ Selecting (Choosing) a HW Interface IDH_auswahl_hw_interface”).

Diagnosis protocol is selected by means of the menu option Communication à Diagnosis Report in Expert mode (see “ Selecting (Choosing) a Diagnosis Protocol IDH_auswahl_diagnoseprotokoll”).

P-SGBD is selected by pressing the function key "P-SGBD" in Expert mode (see “ Function: Loading a P-SGBD IDH_funktion_p_sgbd_laden”).

PABD is selected by pressing the function key "PABD" in Expert mode (see “ Function: Loading a PABD IDH_funktion_pabd_laden”).

Control unit address is entered by pressing the function key "ECU Address" in Expert mode (see “ Function: Loading an ECU addressIDH_funktion_sg_adresse_laden”).

Data file is selected by pressing the function key "Data File" in Expert mode (see “ Function: Loading a Data Set – Data File IDH_funktion_datensatz_laden_daten”).

Program file is selected by pressing the function key "Program File" in Expert mode (see “ Function: Loading a Data Set – Program File IDH_funktion_datensatz_laden_programm”).

NAAB file is selected by pressing the function key "NAAB File" in Expert mode (see “ Function: Loading a Data Set – NAAB File IDH_funktion_datensatz_laden_naab”).


Saving a Configuration for Expert Mode

If you have activated Expert mode at least once while using WinKFPT, you have the option before exiting WinKFPT of saving the current settings you have made in Expert mode IDH_experten_modus so that you can call them up again the next time you start the program.

To this end, the following dialog box appears before WinKFPT is exited:

Fig.: Saving a configuration for Expert mode

The figure shows a complete set of configuration settings as an example.

The configuration can be saved by clicking "OK" or discarded by clicking "Cancel".

The configuration is saved in WINKFPT.INI in the [Expert mode configuration] section (see “ Configuration in WINKFPT.INI IDH_konfiguration_in_winkfpt_ini”).


Loading a Configuration for Expert Mode

If a configuration with at least one entry exists - either following starting of the program from the configuration file WINKFPT.INI or from a previous entry in Expert modeIDH_experten_modus - this configuration is offered to the user for loading when the user first enters or re-enters Expert mode.

The following dialog box appears:

Fig.: Loading a configuration for Expert mode

The configuration can be adopted by clicking "OK" or discarded by clicking "Cancel".

If the PABD format of the PABD does not match up with the format currently set, the user is informed of this and he can have the format changed automatically.

If the configuration is adopted, the corresponding status displays in the main menu window of WinKFPT are updated (see “ Status Displays of WinKFPTIDH_statusanzeigen_des_winkfpt”).

If the configuration is adopted, the scope of the job data in the configuration determines the function level of Expert mode to which is switched (see “ Function Phases in Expert Mode IDH_funktionsebenen_im_experten_modus“).


Deleting a Configuration for Expert Mode

In contrast to configuration loading, it is also possible to save a totally empty configuration on exiting the program and thus to delete all the entries in the [Expert-Modus-Konfiguration] section of WINKFPT.INI.

To delete configuration settings, perform the following steps:

· Start WinKFPT.

· Start Expert mode by clicking "Expert Mode".

· Click "Cancel" in the "Load last configuration?" dialog box.

· Exit WinKFPT by selecting End à Exit.

· The dialog box "Save last configuration?" then displays an empty configuration for saving. Save this empty configuration by clicking "OK".

WinKFPT is exited and the configuration entries in the [Expert-Modus-Konfiguration] section of WINKFPT.INI are deleted.

The next time WinKFPT is started and Expert mode called, the program does not offer any configuration settings for loading.


Configuration in EDIABAS.INI

The initialization file "<ediabas>\CFGDAT\EDIABAS.INI" contains the configuration for the diagnosis HW interface.

Configuration entry | Possible setting | Default | Description
[Configuration] | This section contains configuration entries for EDIABAS.
Interface |  | EDIC | The identifier entered is initialized as the default HW interface when WinKFPT is started without calling parameters.

Table: Configuration in EDIABAS.INI


Reference Configuration of WinKFPT

The following figures show the default configuration for WinKFPT after reinstallation:

[Einstellungen]

; allgemeine Einstellungen

WindowPosition=0,1,-1,-1,-1,-1,0,0,643,424

U_PROG=ON

SCHNELLE_BAUDRATE=ON

ANZEIGE_U_PROG=OFF

TEST_CHECKSUMME=ON

PROGRAMM_ERZWINGEN=OFF

; Aif schreiben

AIF_SCHREIBEN_NACH_DATEN=OFF

AIF_SCHREIBEN_NACH_PROGRAMM=OFF

EXPERT_MIT_AIF=OFF

KOMFORT_MIT_AIF=OFF

; Trace

API_TRACE=ON

IFH_TRACE=ON

[HW-Interface]

K-Line / ADS=ADS

K-Line / EDIC=EDIC

K-Line / ADS-OBD=STD:OBD

CAN / EDIC=EDICC

CAN / Vector=STD:CAN

Most / Optolyzer=STD:MOSTO

Most / PC-Karte=STD:MOSTP

Funk / MDA=STD:FUNK

Fig.: Reference configuration in the WINKFPT.INI file

; Initialisierungsdatei fuer COAPIKF-Funktionen

[Pfadangaben]

ERROR_TEXTE = ..\CFGDAT

WORKING_DIR = ..\WORK

; genereller Pfad fuer Kennfeld-Daten

GENERAL_KF_DATA_PATH = ..\DATA

[Kennfeldprog]

TEMP_DAT_FILE_DEFAULT_NAME = KFLISTE.DAT

; Daten

SERIENNUMMER = 42324

KUNDENNUMMER = 12321

KM = 0

ZBNUMMER = 0000000

SWNUMMER = 0000000

TYPNUMMER = 0000000

AEINDEX = 00

; SG Dateien komprimieren

; 1 -> Dateien werden immer komprimiert (Für Datenupdate über Netz

; während Applikation läuft)

Fig.: Reference configuration in the COAPI.INI file

Sektion [Configuration]

;-------------------------------------------------------

; Interface

; Description : Connected diagnosis interface

; Default     = EDIC

Interface=STD:OBD

Fig.: Reference configuration in the EDIABAS.INI file


Starting WinKFPT

You can start WinKFPT without calling parameters or with certain combinations of various calling parameters.

The calling parameters are used to set WinKFPT to a desired operating mode or to preset certain operating parameters in WinKFPT to desired values immediately upon the program being started.


Calling Parameters of WinKFPT

The following calling parameters can be set in WinKFPT:

Parameter name | Parameter value | Description |  | Default
-RUN | - | Starts WinKFPT immediately in Batch mode. Example: winkfpt32 –RUN | -
-BATCH= | <Control file> | Path and name of a control file for Batch mode. Example: winkfpt32 –RUN –BATCH=update_ek928 | “<root>IDH_footnote_root\bin\winkfpt.ctl”
-INTERFACE= | <HW interface> | Defines the HW interface (e.g. ADS, EDIC) that is to be active following starting of WinKFPT. It can be altered at a later point in Dialog mode by means of the main menu option "HW Interface". Example: winkfpt32 –INTERFACE=STD:OBD | Setting in "EDIABAS.INI"
-UNIT= | <Interface unit> | Defines the unit (_, A, B, C, ....., Z) that is to be active following starting of WinKFPT. It can be altered at a later point in Dialog mode by means of the main menu option "HW Interface". Example: winkfpt32 –UNIT=A | “_“
-WITH_MOSTFIREWALL= | <ON/OFF> | Relays the value to the PABD as the parameter "WITH_MOSTFIREWALL". Example: winkfpt32 –WITH_MOSTFIREWALL=ON | “OFF“
-TESTER_ID= | <Hex value> | Relays the value to the PABD as the parameter "TESTER_ID". Example: winkfpt32 -TESTER_ID=FA | “F1“
-C | <PABD file name> | Compiles an IPS file (PABD source file). CabdFormat=COM does not have to be set in WinKfpt.ini and coapi.ini. Example: winkfpt32 –C 16ek928 |

Table: Calling parameters of WinKFPT


Type Description of the Calling Parameters of WinKFPT

The calling parameters of WinKFPT can be divided into 3 type groups:

1. Parameters for setting the operating mode

2. Parameters for Batch mode only

3. General parameters for Batch and Dialog modes

The parameters for setting an operating mode are:

· -C starts WinKFPT in Compile mode – no other parameter is permissible!

· -RUN starts WinKFPT in Batch mode

· no par. If neither –C nor –RUN is specified as the calling parameter WinKFPT starts in Dialog mode, which is the standard operating mode for users employed in control unit development.

The following parameter is used for Batch mode only:

· -BATCH

The general parameters for Batch and Dialog modes are:

· -INTERFACE

· -UNIT

· -WITH_MOSTFIREWALL

· -TESTER_ID


Status Displays of WinKFPT

The following status displays are displayed in the main menu window following user inputs or during automatic routines such as ECU flash programming or importing of files:

Status display

Description

ECU address

The control unit address is only explicitly displayed if the standard description files are used for programming the control unit in question.

No ECU address can be displayed for control units with "older" description files. The following text appears instead:

PABD uses an internal address

Wird angezeigt:

§ following selection of the description files and entry of the ECU address in Expert mode IDH_experten_modus (Dialog mode)

§ following selection of an integration position and entry of the ECU address in Comfort mode IDH_komfort_modus (Dialog mode)

§ during flash programming of an ECU in Batch mode.

Integration position

There are control units for multiple integration that belong to the same ECU family but that have different addresses, e.g. control units for seat occupancy detection.

To improve user friendliness, the software enables you to select a control unit not by means of the ECU address, rather by means of meaningful texts that describe the integration position of the control unit (e.g. Passenger seat, rear left).

These user-selection texts are taken from the file info.GER

These texts are displayed:

§ following selection of an integration position in Comfort mode (Dialog mode).

Vehicle identification number

In the Comfort mode of Dialog mode, the vehicle identification number is displayed only if an entry is made in the UIF (user info field) following flash programming.

The VIN is displayed:

§ following selection of an integration position in Comfort mode (Dialog mode).

§ during flash programming of an ECU in Batch mode (the vehicle identification number from the control file for Batch mode is displayed).

ZB number

The ZB number (assembly identification number) defines the program data set and data data set to be programmed for a control unit.

The ZB number is displayed:

§ in Expert mode (Dialog mode) if an entry would be made in a UIF (user info field) following flash programming. The assembly identification number from the configuration file COAPI.INI is displayed.

§ following selection of an integration position in Comfort mode (Dialog mode).

§ during flash programming of an ECU in Batch mode.

HW number

The hardware number defines the programmed program data set of a control unit.

The hardware number is displayed:

§ during flash programming of an ECU in Expert mode (Dialog mode).

§ during flash programming of an ECU in Comfort mode (Dialog mode).

§ during flash programming of an ECU in Batch mode.

HW interface

The default HW interface or the one selected is always displayed.

Interface unit

The default interface unit or the one selected is always displayed.

Diagnosis protocol

The default diagnosis protocol or the one selected is always displayed if the ECU facilitates communication with at least 2 diagnosis protocols.

PABD

Flash sequence description file

The file is displayed:

§ following selection in Expert mode (Dialog mode).

§ following selection of an integration position in Comfort mode (Dialog mode).

§ during flash programming of an ECU in Batch mode.

§

P-SGBD

Control unit description file for programming

The file is displayed:

§ following selection in Expert mode (Dialog mode).

§ following selection of an integration position in Comfort mode (Dialog mode).

§ during flash programming of an ECU in Batch mode.

Progress bar

Informs you in percentage terms of the progress of an automatic process that takes some time to be executed (0 % - 100 % in 1 % increments).

The progress bar is displayed during:

§ flash programming (program and data).

§ import/export of assembly line data sets, data files or description files.

Boot sector update

Is displayed at all times and informs you of whether the boot sector update is ACTIVATED or NOT ACTIVATED.

The setting can be changed at any time by means of the main menu option "Configuration".

Table: Status displays of WinKFPT


Starting WinKFPT in Compile Mode

There is only one call that can be used to start WinKFPT in Compile mode:

winkfpt32 –C <dateiname>

The file name of the PABD (= IPS file) must be entered without the path and file extension, otherwise WinKFPT is aborted and an error message is displayed that must be acknowledged. CabdFormat=COM does not have to be set manually in WinKfpt.ini and coapi.ini for compilation. This is done automatically and temporary by WinKFPT.

The PABD to be compiled, e.g. 10gd8600.ips, must be present in the "<root>\sgdat" directory.

The following dialog window appears once WinKFPT has been started:

Fig.: Dialog window in Compile mode

If you click "Cancel", WinKFPT is exited without any further reaction.

If you click "OK", the PABD in question is compiled and the result of this compilation displayed in a message box.

In the event of an error, an error report is created in the form of the file cabi.err saved in the <root>\bin directory. This report contains the errors that have occurred during compilation.

Result display when compilation has been successful:

Fig.: Result display in Compile mode – compilation OK

Result display when compilation has not been successful:

Fig.: Result display in Compile mode – compilation not OK

WinKFPT is exited when "OK" is clicked.


Starting WinKFPT in Batch Mode

Batch mode is used to flash program any number of control units one after the other.

Der Batchbetrieb des WinKFPT kann auf zwei Arten eingeschaltet werden:

1. Automatic activation through calling from, for example, an external application using the calling parameter –RUN (see “ Calling Parameters of WinKFPTIDH_aufrufparameter_des_winkfpt”). In this case, Batch mode is already started.

2. Manual activation from within Dialog mode (see “ Display Batch Mode IDH_anzeige_batchmodus”). In this case, Batch mode is not yet started.

Once Batch mode has been activated, another dialog window (WinKFPT Batch mode monitor) that contains the status displays and the function buttons for user inputs in Batch mode is displayed in addition to the main menu window of WinKFPT:

Fig. 4‑4: Dialog window for Batch mode (Batch mode monitor)

The following table describes the status displays in the Batch mode monitor:

Status display | Description
Control file | Path and name of the default control file or of the control file transferred as calling parameter (-BATCH=<controlfile>).
Status | The status display informs the user about the current activity or about error conditions in Batch mode. The following status displays are possible: "not started" "started" "waiting for control file" "reading in control file" "programming active" "waiting for end of programming" "programming ended" "no control file specified" "report file cannot be opened" "WinKFPT Batch mode error" "Batch cannot be started. Programming in progress"
Errors | Indicates the number of errors that occur during control unit communication or during the evaluation of logistics data.
Aborts | Indicates the number of errors that occur during the flash programming of ECUs; an error leads to immediate aborting of programming.
Target interface | Indicates the HW interface+unit that the corresponding WinKFPT instance accesses during flash programming of an ECU.
Mode | Indicates whether a control file for Comfort mode IDH_komfort_modus or for Expert mode IDH_experten_modus is being processed.

Table 4‑3: Status displays in the Batch mode monitor

The following user inputs are possible in Batch mode:

· “Start”: Batch mode is started, i.e. WinKFPT waits for a control file or a existing control file is processed.

· “Stop”: Batch mode is ended, i.e. it can be restarted with "Start" or deactivated by closing the Batch mode monitor.

· “Close dialog”: The Batch mode monitor is closed and Batch mode deactivated.

If Batch mode is started, WinKFPT waits for the Control file indicated. As soon as this file exists, it is opened, evaluated and processed. Depending on the contents of the control file, it is decided whether the process is a Batch process in C omfort mode IDH_komfort_modus or in Expert mode IDH_experten_modus.

The path and name of the control file can be specified when calling using the calling parameter –BATCH=<controlfile>; if specified, the path must be cited in its entirety, including the drive details.

If part of the path is missing, the control file is expected in the installation directory of WinKFPT, <root>IDH_footnote_root\bin>.

There is no need to enter an extension for the control file. It is automatically assumed to be .CTL.


Control File for Batch Mode in Comfort Mode

The control file is processed in order.

Its contents correspond to the entries the WinKFPT user makes in the "Comfort mode IDH_komfort_modus" of Dialog mode (ZB number, ECU address (corresponds to the integration position) and vehicle identification number).

The syntax of the control file is in line with the file format as familiar from Windows INI files and it is divided up into the following sections:

[FGNUMMER] (VIN), [ZBNUMMER] (ZBNUMBER), [SGADRESSE] (ECUADDRESS) and [BATCH].

Other sections are ignored.

The table below contains a full description of the sections of a control file and of the contents of these sections.

Section

Contents

[FGNUMMER]

The [FGNUMMER] (VIN) section has just one line that contains the vehicle identification number.

Format: VIN=<VIN>

Example: VIN=WBAAA00000AA00000

[ZBNUMMER]

The [ZBNUMMER] (ZBNUMBER) section contains the various assembly identification numbers, each on a separate line.

Format: ZBNxxxx=<ZBnumber>, where xxxx is a consecutive number that begins at 0000, and there must be no gap.

Example:

ZBN0000=7539765

ZBN0001=7539767

The control units are programmed according to the sequence of the numbers.

Programming is ended when the first number that no longer has a successor number is reached.

[SGADRESSE]

The [SGADRESSE] (ECUADDRESS) section contains the various ECU addresses, each on a separate line.

Format: SGADRxxxx=<ECUaddress>, where xxxx is a consecutive number that begins at 0000, and there must be no gap.

The ECU address is entered as a HEXADECIMAL.

Example:

SGADR0000=12

SGADR0001=13

There must be an ECU address with an identical consecutive number for each assembly identification number entered.

E.g.:

[ZBNUMMER]

ZBN0000=7515985

[SGADRESSE]

SGADR0000=A2

[BATCH]

The [BATCH] section contains one line with information relating to the ending of Batch mode.

Format: END=ON or END=OFF.

If the section is left blank (i.e. no entry) or is missing, this is interpreted as END=OFF.

The purpose of the END=ON option is to enable WinKFPT to be ended in Batch mode by a calling external application that creates a control file that contains just the section BATCH with the entry END=ON.

Batch mode is ended immediately upon the control file being read in.

If Batch mode was started automatically by means of the calling parameter –RUN, WinKFPT is also ended.

In this case, the FGNUMMER, ZBNUMMER and SGADRESSE sections (if present) are ignored.

Table: Contents of a control file for the Batch mode in Comfort mode

Once the control file has been processed, it is deleted and WinKFPT waits for a new control file.


Control File for Batch Mode in Expert Mode

The control file's contents correspond to the entries the WinKFPT user makes in the "Expert mode IDH_experten_modus" of Dialog mode (PABD, P-SGBD, ECU address, data file, program file, diagnosis protocol and vehicle identification number).

The syntax of the control file is in line with the file format as familiar from Windows INI files. The file has just the one section: [MULTIFLASH]

Other sections are ignored.

The table below contains a full description of the parameters in the [MULTIFLASH] section of a control file:

Parameter | Contents
MF_PABD | This parameter specifies the PABD to be used for programming. Format: MF_PABD=<PABD name> Example: MF_PABD=21EK928.IPO
MF_PSGBD | This parameter specifies the P-SGBD to be used for programming. Format: MF_PSGBD=<P-SGBD name> Example: MF_PSGBD=21EK92.PRG
MF_SG_ADR | The ECU address is entered as a HEXADECIMAL. Format: MF_SG_ADR=<PABD name> Example: MF_SG_ADR=12
MF_DATEN_DATEI | This parameter defines the data file to be programmed. At least one NAAB file, one data file or one program file must be entered. Format: MF_DATEN_DATEI =<Data file name> Example: MF_DATEN_DATEI=Q7525491.0DA
MF_PROGRAMM_DATEI | This parameter defines the program file to be programmed. At least one NAAB file, one data file or one program file must be entered. Format: MF_PROGRAMM_DATEI =<Program file name> Example: MF_PROGRAMM_DATEI=7523523A.0PA
MF_NAAB_DATEI | This parameter defines the NAAB file to be programmed. At least one NAAB file, one data file or one program file must be entered. Format: MF_PROGRAMM_DATEI =<NAAB file name> Example: MF_NAAB_DATEI=555111_555222.0ba
MF_DIAGNOSEPROTOKOLL | This parameter specifies the diagnosis protocol to be used. This is optional. Format: MF_DIAGNOSEPROTOKOLL=<Diagnosis protocol> Example: MF_DIAGNOSEPROTOKOLL=KWP2000*
MF_FG_NUMMER | This parameter specifies the vehicle identification number. It is only required if UIF writing is used for programming. Format: MF_FG_NUMMER=<VIN> Example: MF_FG_NUMMER WBAAA00000AA00000

Table: Contents of a control file for the Batch mode in Expert mode

Once the control file has been processed, it is deleted and WinKFPT terminates itself automatically.


Starting a Programming Job in Batch Mode

Starting the programming job:

The existence of the control file in the relevant directory is the signal for a programming job.

The existence of the control file is determined by WinKFPT in Batch mode by means of polling.

The control file should first of all be written under a different name or in a different directory and then be made visible for Batch mode by being renamed or copied over. This is to prevent uncompleted files from being read in.

The control file is no longer read until processing has been completed.

While WinKFPT is in Batch mode, the EDIABAS-API is released and remains bound to the program only during the period the job is being processed.

For each individual flash programming of an ECU, i.e. for each processing of a VIN from the control file, the same status displays are displayed in the main menu window of WinKFPT as are displayed when programming in Dialog mode.

Process logging:

While the programming job is being processed, a log is generated that has the same path and name as the control file but the extension .PRT.

The following is documented in the log file:

Name of the control file and its date.

Contents of the control file as they have been scanned.

Error during scanning of the control file.

In Comfort mode:

The VIN is entered as FGN=<VIN>.

The ZB number and ECU address are entered at the start of processing.

In Expert mode:

The PABD is entered as MF_PABD=<PABD>.

The P-SGBD is entered as MF_PSGBD=<P-SGBD>.

The ECU address is entered as MF_SG_ADR=<ECU address>.

The data file is entered as MF_DATEN_DATEI=<Data file name>.

The program file is entered as MF_PROGRAMM_DATEI=<Program file>.

The NAAB file is entered as MF_NAAB_DATEI=<NAAB file>.

The VIN is entered as MF_FG_NUMMER=<VIN>.

The diagnosis protocol is entered as MF_DIAGNOSEPROTOKOLL=<Diagnosis protocol>.

The following texts are generated to indicate the result of an individual programming routine:

“ERG=Programming OK “ for correct programming

“ERG=Programming nOK. Abort “ for error during programming

“ERG=Programming nOK. Fatal error “ for error prior to programming.

Messages displayed in Dialog mode of WinKFPT in popup dialog boxes are written to the log file in the format INFOxxx=<Text>, where xxx is a consecutive number.

End of a programming job:

The end of the processing of a job is indicated by deletion of the control file. In Comfort mode IDH_komfort_modus, WinKFPT then waits for a new batch file. In Expert mode IDH_experten_modus, WinKFPT terminates itself once the batch file has been fully processed.


Switching HW Interface and Diagnosis Protocol in Batch Mode

Switching HW interface and diagnosis protocol during the programming of control units in Batch mode in C omfort Mode IDH_komfort_modus is based on the file \<root>IDH_footnote_root\DATA\GDATEN\prgifsel.dat.

This file contains the HW interface and diagnosis protocol that are to be used for the ECU families entered.

If the file "prgifsel.dat" does not exist or if the control unit to be programmed is not entered in this file, the last HW interface that was active prior to starting Batch mode and the default diagnosis protocol for this control unit are set.

The default diagnosis protocol is the first one from the list of diagnosis protocols that the P-SGBD of the control unit returns as the reply to the prompt with regard to the diagnosis protocols implemented.


Starting Several Instances in Batch Mode

In automatic Batch mode, several instances of WinKFPT can be run and process control files simultaneously.

Note that two instances of WinKFPT are not able to use the same control file.

Apart from that, each instance must communicate over a different piece of hardware (hardware interface + unit) while its control file is being processed.

If two instances want to access the same control file, the following error message is displayed:

Fig.: Error message when two instances access the same control file

To prevent two Batch mode instances from wanting to access the same control unit, the calling parameter –BATCH=<Control file> must be used.

This applies not only to automatic activation (starting WinKFPT with -RUN parameter), but also to manual activation of Batch mode (starting WinKFPT without -RUN parameter).

Whatever the case, two WinKFPT instances are never able to communicate with a control unit via the same HW interface+unit.

To define the interface and the unit for a WinKFPT instance at the time of starting, you can use the command line parameters -INTERFACE=<HW interface> and -UNIT=<Unit identifier>.

Batch mode has a special feature by which two WinKFPT instances can be started that display the same target interface in the Batch mode monitor, i.e. they have been started with the same HW interface+unit details.

A HW interface conflict only arises when the two instances process their control file simultaneously and want to access the same HW interface.

Only that instance that begins processing first is able to access the HW interface properly; the HW interface is blocked for the second instance from this point to the time processing of the first instance has been completed.


Starting WinKFPT in Dialog Mode

All calling parameters except "-C" and "-RUN" may be used to start a WinKFPT instance in Dialog mode.

Calling WinKFPT without calling parameters always starts a WinKFPT instance in Dialog mode.


Starting Several Instances in Dialog Mode

Like in Batch mode, it is theoretically possible to call and run up to 99 different WinKFPT instances simultaneously in Dialog mode, too.

Since the default HW interface+unit or the HW interface+unit entered as the calling parameter is always accessed immediately when WinKFPT is started in Dialog mode, it is not possible for two instances to be started that want to access the same HW interface+unit.

In such a case, the second instance starts with the error message:

or

Fig.: Error message when the same HW interface+unit is accessed

Once you have acknowledged the error message by clicking "OK", the second instance is automatically closed again.


WinKFPT's Main Menu

The top menu bar offers the user the following main menu options:

· DisplayIDH_menue_anzeige

· Import/ExportIDH_menue_import_export

· CommunicationIDH_menue_kommunikation

· ConfigurationIDH_menue_konfiguration

· HelpIDH_menue_hilfe

· EndIDH_menue_ende

When you select a main menu option, a pull-down menu containing one or more submenu options appears via which you can call the various menu options.


File Menu

You use this menu to exit WinKFPT:


Exit

You exit WinKFPT by selecting the menu option File / Exit.

This command terminates the program.

If you have activated Expert mode at least once while using WinKFPT, you have the option before exiting WinKFPT of saving the current settings you have made in Expert mode so that you can call them up again the next time you start the program (see “ Configuration for Expert Mode IDH_konfiguration_fuer_den_experten_modus”).

As WinKFPT is terminated, the last window size and window position of the application are saved as the entry WindowPosition in the WINKFPT.INI file.

The next time WinKFPT is launched, the program is started with the same window size and position (see “ Configuration in WINKFPT.INI IDH_konfiguration_in_winkfpt_ini“).


Display Menu

The main menu option Display contains the following submenu options that be used to switch certain functions ON or OFF and display error and trace files:

· CABI.ERR IDH_anzeige_cabi_err

· ERROR.LOG IDH_anzeige_error_log

· PABD Parameters IDH_anzeige_pabd_parameter

· HW-History IDH_anzeige_hw_historie

· ZB History IDH_anzeige_zb_historie

· ZB Rule IDH_anzeige_zb_vorschrift

· API Trace File IDH_anzeige_api_tracedatei

· IFH-Trace File IDH_anzeige_ifh_tracedatei

· Batch Mode IDH_anzeige_batchmodus


Display CABI.ERR

Displays the CABI.ERR file that contains the error messages created when an error occurs during translation of a PABD (= IPS file).

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display ERROR.LOG

Displays the ERROR_INTERFACE_UNIT.LOG error file that contains the error messages from the COAPI and CDH functions.

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display PABD-Parameters

Displays the job and result parameters currently set for a PABD.

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display HW-History

Displays the HW history of the current hardware number.

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display ZB History

Displays the ZB history of the current hardware number.

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display ZB Rule

Displays the ZB rule of the current assembly identification number.

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display API-Trace File

Displays an API trace file present in the EDIABAS directory.

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display IFH-Trace File

Displays an IFH trace file present in the EDIABAS directory.

Close the display by clicking OK or by pressing "ESC" or Alt+F4.


Display Batch Mode

Switches from Dialog mode to Batch mode.

Batch mode is not yet started following this switching.


Import/Export Menu

Selecting this main menu option opens up the following submenu:

Fig.: Submenu under the main menu option <Import/Export>


Import Submenu

This submenu option in turn activates a pull-down menu that contains the following options:

Fig.: Pull-down menu under the submenu option <Import>

The Import menu can be used to select all the files necessary for flash programming. They can be selected from any drive or directory. The files selected are then automatically distributed to the appropriate directories once their adoption has been confirmed.

The following file groups can be imported:

Import | Files
Data sets / Program releases / BSU NAAB-files IDH_import_von_datensaetzen_programm_und_daten | *.0DA *.DAF *.0PA *.PAF *.0BA *.BAF | Data set files for data Data exchange files Data set files for program Program exchange files Data set files for NAAB NAAB exchange files
P-SGBD IDH_import_von_programmier_steuergeraetebeschreibungsdateien | *.PRG | P-SGBD in compiled code
PABD IDH_import_von_programmier_ablaufbeschreibungsdateien | *.IPS *.IPO | PABDs in source code PABDs in compiled code
Assembly line data IDH_import_von_werksdaten | *.0DA *.0PA *.0BA *.PRG *.IPS *.IPO *.DAT *.DA2 *.HWH *.HIS *.ATS *.ASD *.AS2 *.GER *.BSU | Data set files for data Data set files for program Data set files for NAAB P-SGBD in compiled code PABDs in source code PABDs in compiled code ECU logistics files Assignment of ECU members to names of logistics files History of compatible hardware numbers of an ECU family Compatible assembly identification numbers of an ECU family Logistics file Logistics file Authentication code files ECU member integration position Logistics file for checking the possibility of a BSU (boot sector update)
Exported configuration – development data IDH_import_exportierte_konfiguration_entwicklungsdaten |  | Files like from import of assembly line data + development files and/or tool-relevant files if desired by user
Exported configuration - assembly line data IDH_import_eportierte_konfiguration_werksdaten |  | Files like from import of assembly line data + tool-relevant files if desired by user

Table: Import files

The importing of exported configuration development data‚ data sets, program data sets, /BSU NAAB files, P-SGBDs and PABDs is assigned to "Expert mode".

The import of exported configuration assembly line data and assembly line data is assigned to "Comfort mode".


Importing an "Exported Configuration" of Assembly Line Data

You import an "exported configuration" of assembly line data by selecting the menu option Import/Export à Import à Exported configuration - assembly line data.

The following dialog window is then displayed to enable you to select the import directory:

Fig.: Selecting the import directory of a configuration of assembly line data

The start directory highlighted in the import dialog window for the first import in a WinKFPT session is "My Computer". For each subsequent import, the import directory highlighted is the one that was selected the last time.

A configuration of exported assembly line data can only be imported from directories that contain the export log file BACKUPEXPORT.LOG. The contents of the log file are not checked.

If the directory selected does not contain this log file, an error message is displayed and the dialog terminated.

It is only possible to import an entire exported configuration, i.e. you are not able to select parts from the exported WDPs for import.

Before importing is performed, a check is run to determine whether or not one or more of the WDPs to be imported is/are already present in the "<root>\Data" directory.

A dialog window appears that contains a list of the WDPs already in this directory and the function buttons "Replace", "Merge" and "Cancel".

Fig.: WDP conflict when importing a configuration of assembly line data

If the list of WDPs is empty, the list window and its corresponding headline is not shown. The "Merge" button is not shown too because has not function and the "Replace" button is changed by the "Import" button

Furthermore, you can also specify whether you want to import with or without tool-relevant data (INI files) (default is "Import - Tool relevant data" not activated).

Tool-relevant files from the import directory always overwrite those files in the working directory that have the same name.

KMM files are exported for archiving purposes only and are therefore never reimported.

The buttons have the following functions:

· Cancel (always active):

the dialog window is closed and no files are imported.

· Replace and Import respectively(always active):

all the files from the import directory selected are copied to the working directory; files that are already present are overwritten.

· Merge (only active when the WDP list is not empty):

only those files that have a more recent date are copied from the import directory to the working directory.

The following COMMON files are given 'special treatment' that is identical for the two import modes Replace and Merge:

KFCONFXX.DA2, HWNR.DA2 and SWTCONFx.DAT:

In the file in the working directory, all lines that relate to the ECU family of the assembly line data set to be imported are overwritten if they are already present or appended if they are not already present.

Special treatment, which is only valid for the import mode Merge, is given to the following ECU-specific file:

<ECUFAMILY>.DAT:

All lines from the file in the import directory that do not yet exist in the file in the working directory are appended to the DAT file in the working directory. This operation is only executed for lines that begin with a number, i.e. not for lines that in particular begin with "$" or ";".


Importing an "Exported Configuration" of Development Data

You import an "exported configuration" of development data by selecting the menu option Import/Export à Import à Exported configuration - development data.

The following dialog window is then displayed to enable you to select the import directory:

Fig.: Selecting the import directory of a configuration of development data

The start directory highlighted in the import dialog window for the first import in a WinKFPT session is "My Computer". For each subsequent import, the import directory highlighted is the one that was selected the last time.

A configuration of exported development data can only be imported from directories that contain the export log file CONFIGEXPORT.LOG. The contents of the log file are not checked.

If the directory selected does not contain this log file, an error message is displayed and the dialog terminated.

It is only possible to import an entire exported configuration, i.e. you are not able to select parts from the exported WDPs for import.

Before importing is performed, a check is run to determine whether or not one or more of the WDPs to be imported is/are already present in the "<root>\Data" directory.

A dialog window appears that contains a list of the WDPs already in this directory and the function buttons "Replace", "Merge" and "Cancel".

Fig.: WDP conflict when importing a configuration of development data

If the list of WDPs is empty, the list window and its corresponding headline is not shown. The "Merge" button is not shown too because has not function and the "Replace" button is changed by the "Import" button

A separate selection element enables you to active or deactivate importing of the development files, i.e. files from the

<basedirectory>\<configurationname>\Daten\Entwicklung\Data\Develop

<basedirectory>\<configurationname>\Daten\Entwicklung\Sgdat

<basedirectory>\<configurationname>\Daten\Entwicklung\Ecu

directories (default is "Import - Development files" activated).

Note:

The files from the export directory

<basedirectory>\<configurationname>\Daten\Entwicklung\Data\Gdaten

are not reimported.

Furthermore, you can also specify whether you want to import with or without tool-relevant data (INI files) (default is "Import - Tool relevant data" not activated).

Development files and tool-relevant files from the import directory always overwrite those files in the working directory that have the same name.

The buttons have the following functions:

· Cancel (always active):

the dialog window is closed and no files are imported.

· Replace and Import respectively(always active):

all the files from the import directory selected are copied to the working directory; files that are already present are overwritten.

· Merge (only active when the WDP list is not empty):

only those files that have a more recent date or are not yet preset are copied from the import directory to the working directory.

The following COMMON files are given 'special treatment' that is identical for the two import modes Replace and Merge:

KFCONFXX.DA2, HWNR.DA2 and SWTCONFx.DAT:

In the file in the working directory, all lines that relate to the ECU family of the assembly line data set to be imported are overwritten if they are already present or appended if they are not already present.

Special treatment, which is only valid for the import mode Merge, is given to the following ECU-specific file:

<ECUFAMILY>.DAT:

All lines from the file in the import directory that do not yet exist in the file in the working directory are appended to the DAT file in the working directory. This operation is only executed for lines that begin with a number, i.e. not for lines that in particular begin with "$" or ";".


Importing Assembly Line Data

You import assembly line data by selecting the menu option Import/Export à Import à Assembly line data.

The following dialog window is then displayed to enable you to select the import directory:

Fig.: Selecting the import directory for assembly line data sets

The start directory highlighted in the import dialog window for the first import in a WinKFPT session is "My Computer". For each subsequent import, the import directory highlighted is the one that was selected the last time.

The directory selected contains either an actual assembly line data set or one or more subdirectories that contain assembly line data sets.

In the example above, you could select either "G:\Trans\EK9282" or "G:\Trans".

WinKFPT automatically finds all data sets immediately in the selected directory or one directory level lower and executes the import for each data set.

If in the example above you were to select "G:\Trans\EK9282" as the import directory, only the data set "EK928" would be imported; if you selected "G:\Trans", data sets "EK9282", "EK9294B" etc. would be imported.

Before importing is performed, a check is run to determine whether or not one or more of the WDPs to be imported is/are already present in the "<root>\NFS\Data" directory.

A dialog window that contains a list of the WDPs already in this directory and the function buttons "Replace", "Merge" and "Cancel" appears only when this is the case.

Fig.: WDP conflict when importing assembly line data sets

The buttons have the following functions:

· Cancel:

the dialog window is closed and no files are imported.

· Replace:

all the files from the import directory selected are copied to the working directory; files that are already present are overwritten.

· Merge:

only those files that have a more recent date or are not yet preset are copied from the import directory to the working directory.

The following COMMON files are given 'special treatment' that is identical for the two import modes Replace and Merge:

KFCONFXX.DA2, HWNR.DA2 and SWTCONFx.DAT:

In the file in the working directory, all lines that relate to the ECU family of the assembly line data set to be imported are overwritten if they are already present or appended if they are not already present.

Special treatment, which is only valid for the import mode Merge, is given to the following ECU-specific file:

<ECUFAMILY>.DAT:

All lines from the file in the import directory that do not yet exist in the file in the working directory are appended to the DAT file in the working directory. This operation is only executed for lines that begin with a number, i.e. not for lines that in particular begin with "$" or ";".

The files are distributed to the following directories when assembly line data is imported:

Files | Target directory
*.PRG | <ediabas>\ecu
*.IPS, *.IPO | <root>\SGDAT\
*.ASD, *.AS2, INFO.GER, HWNR.DA2, KFCONF.DA2, HWNR.DAT, NPV.DAT, KFCONF.DAT , HISTORIE.BSU, SWTCONFx.DAT | <root>\DATA\GDATEN
<SGFAMILIE>.DAT, *.0DA, *.0PA, *.0BA, *.HWH, *.HIS, *.ATS | <root>\DATA\<ecufam>

Table: Distribution of the files to directories when assembly line data is imported


Importing NAAB, Program and Data Data Sets

You import NAAB files, program data sets and data data sets by selecting the menu option Import/Export à Import à Data / Program / BSU NAAB files.

By importing NAAB files, program data sets and data data sets, you select the files you want to use for flash programming in Expert mode IDH_experten_modus and automatically copy them to the appropriate directory.

Fig.: Importing data sets/program data sets/BSU NAAB files

*.BAF, *.0BA, *.PAF, *.0PA, *.DAF and *.0DA files are displayed by default.

To import the files:

· Select the directory with the files you want from the list next to "Search in".

· Select the file(s) to be imported.

You can select a single file from the list simply by clicking it with the left mouse button.

You can select several files to import by holding down the <Ctrl> key

and clicking with the left mouse button.

You can select all the files displayed by pressing <Ctrl> + <A>.

· Then click "Import".

The files you have selected are copied to \<root>\data\develop.

Files that already exist can only be overwritten once a warning prompt has been acknowledged in the positive.

Fig.: Overwriting files during NAAB, data and program file importing

Bei Auswahl von mehreren Dateien wird der Status des Kopiervorgangs als Fortschrittsbalken (0 - 100%) angezeigt.

If you have selected more than one file, the status of the copying procedure is indicated by a progress bar (0 - 100 %).

After being imported, files are displayed in the selection list of the "Loading a data set - NAAB file", "Loading a data set - program file" or "Loading a data set - data file" function in Expert mode (see Function: Loading a Data Set – Program File IDH_funktion_datensatz_laden_programm“ or “ Function: Loading a Data Set – Data File IDH_funktion_datensatz_laden_daten“).


Importing Control Unit Description Files for Programming (P-SGBDs)

You import P-SGBDs by selecting the menu option Import/Export à Import à P-SGBD.

By importing P-SGBDs, you select the control unit description files you want to use for flash programming in Expert mode IDH_experten_modus and automatically copy them to the appropriate directory.

Fig.: Importing P-SGBDs

Only *.PRG files are displayed (default setting).

To import the files:

· Select the directory with the files you want from the list next to "Search in".

· Select the file to be imported.

You can select a single file from the list simply by clicking it with the left mouse button.

You can select several files to import by holding down the <Ctrl> key

and clicking with the left mouse button.

You can select all the files displayed by pressing <Ctrl> + <A>.

· Then click "Import".

The files you have selected are copied to the P-SGBD directory "<ediabas>\ecu".

Files that already exist can only be overwritten once a warning prompt has been acknowledged in the positive.

Fig. 5‑12: Overwriting files during P-SGBD importing

If you have selected more than one file, the status of the copying procedure is indicated by a progress bar (0 - 100 %).

After being imported, files are displayed in the selection list of the "Load P-SGBD" function in Expert mode (see “ Function: Loading a P-SGBD IDH_funktion_p_sgbd_laden“).


Importing Flash Sequence Description Files (PABDs)

You import PABDs by selecting the menu option Import/Export à Import à PABD.

By importing PABDs, you select the flash sequence description files you want to use for flash programming in Expert mode IDH_experten_modus and automatically copy them to the appropriate directory.

Fig.: Importing PABDs

Only *.IPS and *.IPO files are displayed (default setting).

To import the files:

· Select the directory with the files you want from the list next to "Search in".

· Select the file to be imported.

You can select a single file from the list simply by clicking it with the left mouse button.

You can select several files to import by holding down the <Ctrl> key

and clicking with the left mouse button.

You can select all the files displayed by pressing <Ctrl> + <A>.

· Then click "Import".

The files you have selected are copied to "\<root>\sgdat".

Files that already exist can only be overwritten once a warning prompt has been acknowledged in the positive.

Fig.: Overwriting files during PABD importing

If you have selected more than one file, the status of the copying procedure is indicated by a progress bar (0 - 100 %).

After being imported, files are displayed in the selection list of the "Load PABD" function in Expert mode (see “ Function: Loading a PABD IDH_funktion_pabd_laden“).


Export Submenu

This submenu option in turn activates a pull-down menu that contains the following options:

Fig.: Pull-down menu under the submenu option <Export>


Exporting a "Configuration" of Assembly Line Data

You export a "configuration" of assembly line data by selecting the menu option Import/Export à Export à Configuration - assembly line data.

When you select this menu option, the following dialog window appears:

Fig.: Dialog window for exporting a configuration of assembly line data

This dialog window displays the export base directory currently set, e.g. <root>\NFS-Backup", and two input fields ("Type series" and "I-Level") for the names of the two subdirectories.

A list box displays all the valid assembly line data sets (ECU families) available for selection for export. You can select either no data set at all, one, several or all of the assembly line data sets.

If no valid assembly line data exists, the list box is empty and all you can do is export the tool-relevant data by activating the corresponding check box.

With each export, the KMM data from the working directory "<root>\KMM\" is exported implicitly, provided a KMM directory exists.

Before the actual copying process begins, the data to be exported is compared with the corresponding data last exported and located in the highest-order index directory.

Excluded from comparison are the COMMON files because those to be exported cannot as a rule be identical with those previously exported.

This basically results in the following two sequences for the export of assembly line data:

1. No new directories are created, i.e. the index directory is not increased. This is the case if the files to be exported, either all or just some of them, are not yet present in the highest-order index directory, and if all or some of the files present are identical with those to be exported.

All files are deleted from their respective export directory before copying begins.

2. New directories are created, i.e. the index directory is increased automatically. This is the case if one and just one file to be exported is not identical with the corresponding file in the highest-order index directory.

Every export of assembly line data is documented in the export log file "BACKUPEXPORT.LOG" in the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\ directory.

In the event of repeated export to the same directory (<root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\), the relevant information to be stored is in each case appended to the log file that already exists.

The following pieces of information are entered in a log file for each export procedure:

· Date (format: dd.mm.yyyy)

· Export base directory

· Type series

· I-Level

· Index

· With/Without development files

· With/Without tool-relevant data

· ECU family

:

:

· Separating line


Directory Structure for Exporting Assembly Line Data

Fig.: Structure of the target directories for exporting assembly line data


Filing of the Files When Exporting Assembly Line Data

· Export WDPs (if one or more selected)

Flash data, logistics data: The files *.0PA, *.0DA, *.0BA <ECUFAM>.DAT, <ECUFAM>.HIS, <ECUFAM>.HWH and <ECUFAM>.ATS are copied from the <ecufam> directory to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\daten\<ecufam> directory.

COMMON files: COMMON files SWTCONFX.DAT, HISTORIE.BSU, SGIDC.AS2, SGIDD.AS2 and INFO.GER are copied from the <root>\Data\Gdaten directory to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\daten\<ecufam> directory. The relevant parts of the HWNR.DA2, KFCONFXX.DA2 and SWTCONFx.DAT files are determined and only these parts are copied to the <root>\NFS-Backup\<typeseries>\<I-Level>\<index>\daten\<ecufam> directory.

The file name of the COMMON file is adopted unchanged.

PABD: The name of the description file that belongs to the WDP is determined from the KFCONFXX.DA2 and SWTCONFx.DAT file and copied from <root>\Sgdat to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\daten\<ecufam> directory.

FABD: The name of the description file that belongs to the WDP is determined from the SWTCONFx.DAT file and copied from <root>\Sgdat to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\daten\<ecufam> directory.

P-SGBD: The name of the description file that belongs to the WDP is determined from the KFCONFXX.DA2 and SWTCONFx.DAT file and copied from EDIABAS\ECU to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\daten\<ecufam> directory.

SWT-SGBD: The name of the description file that belongs to the WDP is determined from the SWTCONFx.DAT file and copied from EDIABAS\ECU to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<index>\daten\<ecufam> directory.

· Export KMMs (always if present)

Copying of all the files in the <root>\kmmdat\<typeseries>\ directory to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<Index>\kmm\ directory.

· Export tool-relevant data (optional)

Copying of all the files with the extension *.INI from the <root>\NFS\bin\ directory to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<Index>\bin\ directory.

Copying of all the files with the extensions *.INI and *.DAT from the <root>\cfgdat directory to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<Index>\cfgdat\ directory.

Copying of all the files with the extension *.INI from the <root>\EDIABAS\bin\ directory to the <root>\<NFS-Backup>\<typeseries>\<I-Level>\<Index>\EDIABAS\bin\ directory.


Exporting a "Configuration" of Development Data

You export a "configuration" of development data by selecting the menu option Import/Export à Export à Configuration - development data.

When you select this menu option, the following dialog window appears:

Fig. 5‑18: Dialog window for exporting a configuration of development data

This dialog window displays the export base directory currently set, e.g. "<root>\Diagprog", and one input field ("Configuration name") for the name of the subdirectory.

A list box displays all the valid assembly line data sets (ECU families) available for selection for export. You can select either no data set at all, one, several or all of the assembly line data sets.

If no valid assembly line data exists, the list box is empty and all you can do is export the development files and/or tool-relevant data by activating the corresponding check box(es).

All files selected for export are copied.

If the files are to be exported to a directory ("Configuration name") that already exists, the following prompt is displayed:

Fig.: Prompt asking whether development data should be overwritten during export

If you click "Yes", all the files in the existing directories are deleted first before exporting is conducted.

Every export of development data is documented in the export log file "CONFIGEXPORT.LOG" in the <root>\Diagprog\<configurationname>\ directory.

In the event of repeated export to the same directory (<root>\Diagprog \<configurationname>\), the relevant information to be stored is in each case appended to the log file that already exists.

The following pieces of information are entered in a log file for each export procedure:

· Date (format: dd.mm.yyyy)

· Export base directory

· Configuration name

· With/Without development files

· With/Without tool-relevant data

· ECU family

:

:

· Separating line


Directory Structure for Exporting Development Data

Fig.: Structure of the target directories for exporting development data


Filing of the Files When Exporting Development Data

· Export development files (if released for export)

Flash data: The files *.0PA, *.0DA, *.0BA, *.PAF, *.DAF and *.BAF are copied from the NFS\Data\Develop directory to the <root>\Diagprog\<configurationname>\Daten\Entwicklung\Develop directory.

COMMON files: COMMON files SWTCONFX.DAT, HISTORIE.BSU, SGIDC.AS2, SGIDD.AS2, HWNR.DA2, INFO.GER, KFCONFXX.DA2 and SWTCONFx.DAT are copied from the NFS\Data\Gdaten directory to the <root>\Diagprog\<configurationname>\Daten\Entwicklung\Gdaten directory.

P-SGBDs: All *.PRG files are copied from the EDIABAS\ECU directory

to the <root>\Diagprog\<configurationname>\Daten\Entwicklung\Ecu directory.

PABDs: All *.IPS and *.IPO files are copied from the NFS\Sgdat directory to the <root>\Diagprog\<configurationname>\Daten\Entwicklung\Sgdat directory.

· Export WDPs (if one or more selected)

Flash data, logistics data: The files *.0PA, *.0DA, *.0BA <ECUFAM>.DAT, <ECUFAM>.HIS, <ECUFAM>.HWH and <ECUFAM>.ATS are copied from the <ecufam> directory to the <root>\Diagprog\<configurationname>\Daten\<ecufam> directory.

COMMON files: COMMON files SWTCONFx.DAT, HISTORIE.BSU, SGIDC.AS2, SGIDD.AS2 and INFO.GER are copied from the NFS\Data\Gdaten directory to the <root>\Diagprog\<configurationname>\Daten\<ecufam> directory. The relevant parts of the HWNR.DA2, KFCONFXX.DA2, STWCONFx.DAT files are determined and only these parts are copied to the <root>\Diagprog\<configurationname>\Daten\<ecufam> directory. The file name of the COMMON file is adopted unchanged.

PABD: The name of the description file that belongs to the WDP is determined from the KFCONFXX.DA2 and SWTCONFx.DAT file and copied from NFS\Sgdat to the <root>\Diagprog\<configurationname>\Daten\<ecufam> directory.

FABD: The name of the description file that belongs to the WDP is determined from the SWTCONFx.DAT file and copied from NFS\Sgdat to the <root>\Diagprog\<configurationname>\Daten\<ecufam> directory.

P-SGBD: The name of the description file that belongs to the WDP is determined from the KFCONFXX.DA2 and SWTCONFx.DAT file and copied from EDIABAS\ECU to the <root>\Diagprog\<configurationname>\Daten\<ecufam> directory.

SWT-SGBD: The name of the description file that belongs to the WDP is determined from the SWTCONFx.DAT file and copied from EDIABAS\ECU to the <root>\Diagprog\<configurationname>\Daten\<ecufam> directory.

· Export tool-relevant data (optional)

Copying of all the files with the extension *.INI from the <root>\bin\ directory to the <root>\Diagprog\<configurationname>\NFS\bin\ directory.

Copying of all the files with the extensions *.INI and *.DAT from the <root>\cfgdat directory to the <root>\Diagprog\<configurationname>\NFS\cfgdat\ directory.

Copying of all the files with the extension *.INI from the <root>\EDIABAS\bin\ directory to the <root>\Diagprog\<configurationname>\EDIABAS\bin\ directory.


Deleting Assembly Line Data

You delete assembly line data by selecting the menu option Import/Export à Delete - assembly line data.

If there is no assembly line data present, the following message is displayed:

Fig.: Deleting assembly line data; message if no assembly line data is present

In this case, it is also not possible to conduct flash programming of ECUs in Comfort mode. You would first have to import assembly line data to enable flash programming.

If valid assembly line data does exist, the following dialog window is opened:

Fig.: Dialog window for deleting assembly line data

A list box displays all the valid assembly line data sets (ECU families) available for selection for deletion. You can select either no data set at all, one, several or all of the assembly line data sets.

The directories of the assembly line data selected are completely deleted during the deletion procedure.

The associated description files (SGBD/PABD) are likewise deleted, but only if they occur no more than once in "KFCONFXX.DA2" or “SWTCONFx.DAT”, i.e. only if they are not used by one or more other ECU families at the same time.

By clicking the function button "Remove", you delete the selected WDPs from the list box and remove the corresponding entries from the COMMON files "KFCONFXX.DA2", “SWTCONFx.DAT” and "HWNR.DA2".

The following prompt appears before deletion is started:

Fig.: Deleting assembly line data; prompt displayed on clicking "Remove"

If you click the function button "Remove all", all WDPs are selected and deleted, and the COMMON files "KFCONVXX.DA2",SWTCONFx.DAT and "hwnr.da2" are completely emptied with the exception of their headers, i.e. including all "dead" entries for which no WDPs exist.

The following prompt appears before deletion is started:

Fig.: Deleting assembly line data; prompt displayed on clicking "Remove all"

If you click "Yes", deletion is started and the dialog window is closed once deletion has been completed.

If you click "No", the prompt disappears from the screen and the dialog window remains open.

If you click the function button "Cancel", the dialog window is closed; active deletion procedures are not interrupted.


Communication Menu

This menu can be used to set the following parameters for communication between WinKFPT and control units:

· Hardware interface IDH_auswahl_hw_interface

· Diagnosis protocol IDH_auswahl_diagnoseprotokoll

The menu option "HW interface" enables you to switch dynamically between HW interfaces (EDIC, ADS, etc.).

The "HW interface" menu option is only active if HW interfaces are entered in the configuration file WINKFPT.INI (see “ Configuration in WINKFPT.INI IDH_konfiguration_in_winkfpt_ini”).

The menu option "Diagnosis protocol" enables you to choose dynamically between the diagnosis protocols that are supported by a selected control unit (BMW-Fast, KWP2000, etc.).

The "Diagnosis protocol" menu option is only active if a selected control unit supports more than one diagnosis protocol.

A control unit is selected by selecting an integration position (Comfort Mode IDH_komfort_modus) or by selecting a PABD and P-SGBD (Expert Mode IDH_experten_modus).


Selecting (Choosing) a HW Interface

You choose a HW interface by selecting the menu option Communication à HW interface.

Fig.: Selection dialog for HW interface

The "HW interface" menu option is only active if HW interfaces are entered in the configuration file WINKFPT.INI.

All HW interface entries from WINKFPT.INI (see “ Configuration in WINKFPT.INI IDH_konfiguration_in_winkfpt_ini”) are presented in a list for selection.

You must select a unit identifier (_, A, B, C, D, E) for each HW interface.

The HW interface unit is required by EDIABAS to enable it to distinguish between interfaces if several HW interfaces of the same type are integrated (installed) in one computer.

To choose a HW interface:

· Choose a HW interface from the "HW interface" list.

· Select the unit for the HW interface.

If only one interface of this type is integrated in the computer, you must select "_" (= default).

· Then click "OK".

If WinKFPT is able to activate the HW interface chosen, the interface is displayed constantly in the "HW interface" box as status information. Otherwise, error message 304 (which you have to acknowledge) appears and the previous setting remains active.

Fig.: Error message displayed when an impermissible choice of HW interface is made

The same error occurs if, for example, the HW interface chosen is not installed as hardware or software.

If a different instance of WinKFPT has already accessed the same HW interface+unit, the following error message appears:

Fig.: Error message when the same HW interface+unit is accessed in Dialog mode

When WinKFPT is started, the HW interface defined in "EDIABAS.INI" is activated and displayed by default (see “ Configuration in EDIABAS.INI IDH_konfiguration_in_ediabas_ini”).

You can, however, select a different setting straight away when starting a further WinKFPT instance with the aid of the calling parameters -INTERFACE=<HW interface> and -UNIT=<Unit identifier>.


Selecting (Choosing) a Diagnosis Protocol

You choose a diagnosis protocol by selecting the menu option Communication à Diagnosis protocol.

Fig.: Dialog box for selecting a diagnosis protocol

The "Diagnosis protocol" menu option is only active if a selected control unit supports more than one diagnosis protocol.

A control unit is selected by selecting an integration position (Comfort mode IDH_komfort_modus) or by selecting a PABD and P-SGBD (Expert mode IDH_experten_modus).

Once you have chosen a control unit, WinKFPT automatically tries to call the job "DIAGNOSEPROTOKOLL_LESEN" from the corresponding P-SGBD.

If the job is present, the diagnosis protocols specified in it are displayed in a list for selection.

If you do not make an explicit selection, the first diagnosis protocol from the list is activated by default.

To choose a diagnosis protocol:

· Choose a diagnosis protocol from the "Diagnosis protocol" list.

· Then click "OK".

The diagnosis protocol activated is displayed in the "Diagnosis protocol" box a status information.

A selected diagnosis protocol is set internally by means of the P-SGBD job "DIAGNOSEPROTOKOLL_SETZEN".


Configuration Menu

When you select this menu, the following configuration dialog window is opened.

Fig. 5‑29: Configuration dialog window

The settings correspond to the following INI parameters:

Dialog text | Ini file entry | Description
Sprache / Language | SPRACHE | The entry defines the language for WinKFPT. Options: German (ger) and English (eng).
Programming voltage | U_PROG | The entry specifies whether the programming voltage is switched ON or OFF during flash programming.
Show programming voltage | ANZEIGE_U_PROG | The entry specifies whether the value of the programming voltage is displayed (ON) or not (OFF) during flash programming.
Fast baudrate | SCHNELLE_BAUDRATE | The entry specifies whether the fast baudrate is used (ON) or not (OFF) during flash programming.
Test Checksum | TEST_CHECKSUMME | The entry specifies whether the checksum is validated (ON) or not (OFF) after programming of the data.
activate Bootsectorupdate | BsuActive | The entry specifies whether a boot sector update, i.e. flash programming of an NAAB file, is possible or not.
Force program programming in comfort mode | PROGRAMM_ERZWINGEN | The entry specifies whether, during flash programming in Comfort mode, a program is to be programmed whatever the case, even if only data programming would be necessary.
UIF write after data | AIF_SCHREIBEN_NACH_DATEN | The entry specifies whether the UIF is also programmed (ON) or not (OFF) during data programming in Comfort or Expert mode.
UIF write after program | AIF_SCHREIBEN_NACH_PROGRAMM | The entry specifies whether the UIF is also programmed (ON) or not (OFF) during program programming in Comfort or Expert mode.
UIF write in expert mode | EXPERT_MIT_AIF | The entry specifies whether the UIF is also programmed (ON) or not (OFF) during flash programming in Expert mode.
UIF write in comfort mode | KOMFORT_MIT_AIF | The entry specifies whether the UIF is also programmed (ON) or not (OFF) during flash programming in Comfort mode.
PABD format | CabdFormat | The entry defines whether WinKFPT is to use PABDs as source files or as compiled files. IPS PABDs as source files IPO PABDs as compiled files
API tracelevel | API_TRACE | The entry specifies the level for the API traces in Ediabas (0 means that the trace is switched off).
IFH tracelevel | IFH_TRACE | The entry specifies the level for the IFH traces in Ediabas (0 means that the trace is switched off).
Directory for error file "error.log" | ErrorLogPath | Storage directory for the ERRORn.LOG file
Base directory for exported configurations – development data | ExpertKonfPath | Base directory for export of a configuration of development data (Expert mode).
Base directory for exported configurations – assembly line data | KomfortKonfPath | Base directory for export of a configuration of assembly line data (Comfort mode).
Base directory for working directories of WinKFPT | CoapiSearchPath | Base directory for working directories: cfgdat, data, sgdat etc.

If you close the dialog window by clicking "OK" and the settings in the window differ from those in the Ini file, you are asked whether you would like to save your changes permanently to the Ini file. Even if you reject this option now, the settings you have entered remain valid for the duration of the WinKFPT session, and you are given another chance to save this configuration to the Ini file when you end the session.

If you change the PABD format and a PABD has already been selected, you must then explicitly select a new PABD in Expert mode or implicitly select a new PABD in Comfort mode by selecting an assembly identification number (ZB number). Message boxes prompt you to do this.


Help Menu

This menu is used to start the online help and display information about the program.


Contents - Calling the Online Help

You call the online help by selecting the menu option Help à Contents.

This command displays the opening screen of the online help function.

The User's Guide and the online help are identical.

Whenever updates of WinKFPT are released, the Word file of the User's Guide and the online help will both be updated.

Fig.: Online help of WinKFPT


Info - Version Information of WinKFPT

You display the version information of WinKFPT by selecting the menu option Help à Info.

This command displays the program version and copyright information.

Fig.: Program version and copyright information

The top part of this window shows the version of WinKFPT and the versions of the COAPI and Krapi libraries.

Displayed in the bottom right-hand corner are the creation date and time of the WinKFPT version.


Functions of WinKFPT

Fig.: Functional hierarchy phases of WinKFPT


Function Start Menu: Operating Modes of WinKFPT

This function menu is opened when a WinKFPT instance is started.

The function start menu offers you two WinKFPT operating modes to choose from:

· Comfort mode IDH_komfort_modus

· Expert mode IDH_experten_modus

Fig.: Function start menu of WinKFPT

Each of these two operating modes offers functions that can be divided into two phases:

· Functions of the programming settings phase

· Functions of the programming execution phase.

The operating modes differ with respect to their

· functions for entering and selecting job data for ECU flash programming during the programming settings phase.

· functions for flash programming control unit during the programming execution phase.

Use of the "general functions" is identical in both operating modes (see “ General Functions IDH_allgemeine_funktionen“).

The following table contains the job data possible in the two operating modes:

Mode | Job data
Comfort mode | Name of the control unit family Assembly identification number Integration position <Vehicle identification number>
Expert mode | P-SGBD PABD ECU address Data set name for NAAB Data set file for program Data set file for data <Vehicle identification number>

Table: Overview of the job data in the operating modes

§ <Vehicle identification number>

The vehicle identification number (VIN) only has to be entered (irrespective of the mode) if you are flash programming with subsequent writing of the user info field (UIF).

Flash programming with/without UIF writing can be set by means of the configuration file "winkfpt.ini".

§ ECU address

Whether or not you need to enter the ECU address in Expert mode depends on the state of development of the description files.

In the older description files - these are as a rule the non-standardized description files - the ECU address is hard-coded for filling the protocol parameters and diagnosis telegrams.

The new standard description files must be fed an ECU address from outside, in this case by means of a user input. This address is then saved globally for further processing in the description files.

Whether or not the ECU address has to be entered is determined automatically by WinKFPT and displayed to you on the screen.

§ Description files and data set files

In Comfort mode, the description and data set files required for flash programming are determined from the job data with the aid of the BMW logistics files.


Comfort Mode

This mode is used for flash programming control units, including all logistical checks that, for example, have to be conducted for end-of-line programming at the factory.

Prerequisite for flash programming of a control unit in Comfort mode is the presence of a complete assembly line data set for this control unit (see “ Import SubmenuIDH_import_von_werksdaten”).

Control units can be flashed in Comfort mode in the following ways:

Ø Entry or selection of the assembly identification number (ZUSB number), selection of any number of integration positions offered for the ZUSB number, entry of the vehicle identification number (VIN) when a UIF is written, and subsequent flash programming of the control unit or control units.

Ø Selection of a control unit family and of any number of integration positions offered for this family, and subsequent updating of the control unit or control units to the latest assembly identification, whereby updating to an incompatible hardware release by means of a BSU is also taken into account.


Starting Comfort Mode

Comfort mode is started either by clicking the function button "Comfort mode" or by pressing function key <F1> on the keyboard.

The "Comfort mode" function button is available in the following function phases:

§ in the function start menu (see “Fig.: Function start menu of WinKFPTIDH_funktionsstartmenue_bedienermodi_des_winkfpt“)

§ in the function menu of the programming execution phase of Comfort mode (see “Fig.: Programming execution phase in Comfort mode IDH_funktionen_der_programmierdurchfuehrungsebene_im_komfort_modus“)

§ in the function menu of the programming execution phase of Expert mode (see “Fig.: Programming execution phase in Expert mode IDH_funktionen_der_programmierdurchfuehrungsebene_im_experten_modus“)

Only PABDs in IPO format are used in Comfort mode. If the IPS format is set in the configuration when Comfort mode is entered, the following message box appears:

Fig.: Format switchover on entering Comfort mode.

If you click "OK", the PABD format is automatically set to IPO; if you click "Cancel", you do not enter Comfort mode.

The "Comfort mode" button takes you to the programming settings phase of Comfort mode to enable you to enter job data required for flash programming.

When you activate "Comfort mode", the following job data and status displays from the preceding session in Comfort mode are deleted:

· ECU address or integration position

· Diagnosis protocol

· PABD

· P-SGBD

The job data and status displays:

· Vehicle identification number

· Assembly identification number

· Hardware number

are retained.

When you activate "Comfort mode", the job data and status displays from the preceding session in Expert mode are either completely deleted or are buffered for loading the last configuration for a renewed entry into Expert mode.


Exiting Comfort Mode

Comfort mode can be exited in two ways:

Ø By switching to Expert mode IDH_experten_modus

Ø By deleting the job data for Comfort mode.

Ø You switch to Expert mode by activating the function button "Expert mode".

When you activate "Expert mode", the following job data and status displays of Comfort mode are deleted:

· Vehicle identification number

· Assembly identification number

· Hardware number

The job data and status displays:

· ECU address or integration position

· Diagnosis protocol

· PABD

· P-SGBD

are retained and lead in Expert mode to the switch to programming settings phase Level 2 (see: Fig.: Programming settings phase Level 2 in Expert mode IDH_funktionen_der_programmiereinstellungebene_stufe_2_im_experten_modus).

Ø To completely delete job data in Comfort mode, the following function buttons must be activated one after the other:

"Expert mode"

"Cancel" (if loading from configuration is offered)

"Done" (<F8> in Expert mode)

"Comfort mode"

"Done" (<F8> in Comfort mode).

Afterwards, WinKFPT displays the function start menu (see: Fig.: Function start menu of WinKFPT IDH_funktionsstartmenue_bedienermodi_des_winkfpt).


Expert Mode

This mode is used to select or enter the job data (PABD, P-SGBD and data sets) and then flash program the control unit.

Prerequisite for flash programming of a control unit in Expert mode is the presence of the description files and data sets wanted for this control unit (see “ Import SubmenuIDH_untermenue_import").

In Expert mode, you do have the possibility of bypassing logistical restrictions by e.g.:

· programming a program data set that is incompatible with the current program data set in the control unit

· "resetting" a control unit by programming "old" program data sets

· programming data sets that do not suit the current program data set in the control unit

Caution!

If you embark on actions of this kind, you must know precisely what you are doing because any error could lead to a control unit being rendered totally unusable for the future. Such a control unit would no longer be able to be flashed via diagnosis communication and would have to be submitted for recycling.

When you select Expert mode, the graphical user interface (GUI) immediately displays the assembly identification number (ZB number) from the configuration file "COAPI.INI" for checking purposes if EXPERT_MIT_AIF=ON is set in the configuration file "WINKFPT.INI".

This ZB number is written to the UIF.

If a different ZB number is to be entered in the UIF, you must carry out the following steps:

· Exit WinKFPT.

Change the entry in "COAPI.INI" (see Configuration in COAPI.INI IDH_konfiguration_in_coapi_ini)

· Restart WinKFPT.


Starting Expert Mode

Expert mode is started either by clicking the function button "Expert mode" or by pressing function key <F2> on the keyboard.

The "Expert mode" function button is available in the following function phases:

§ in the function start menu (see “Fig.: Function start menu of WinKFPT IDH_funktionsstartmenue_bedienermodi_des_winkfpt“)

§ in the function menu of the programming execution phase of Comfort mode (see “Fig.: Programming execution phase in Comfort mode IDH_funktionen_der_programmierdurchfuehrungsebene_im_komfort_modus“)

§ in the function menu of the programming execution phase of Expert mode (see “Fig. Programming execution phase in Comfort mode IDH_funktionen_der_programmierdurchfuehrungsebene_im_experten_modus“)

The "Expert mode" button takes you to the programming settings phase Level 1 or Level 2 of Expert mode to enable you to enter job data required for flash programming.

When you activate "Expert mode", all job data and status displays from the preceding session in Expert mode are retained:

When you activate "Expert mode", the following job data and status displays from the

preceding session in Comfort mode IDH_komfort_modus are deleted:

· Vehicle identification number

· Assembly identification number

· Hardware number

The job data and status displays:

· ECU address or integration position

· Diagnosis protocol

· PABD

· P-SGBD

are retained.


Exiting Expert Mode

You exit Expert mode by:

Ø switching to C omfort mode IDH_komfort_modus

Ø You switch to Comfort mode by activating the function button "Comfort mode".

When you activate" Comfort mode", all job data and status displays of Expert mode are either completely deleted or are buffered for loading the last configuration for a renewed entry into Expert mode.

After you click "Done" (or press <F8> in Comfort mode), WinKFPT displays the function start menu (see: Fig.: Function start menu of WinKFPT IDH_funktionsstartmenue_bedienermodi_des_winkfpt).


Function Phases in Comfort Mode

The functions of Comfort mode are divided into two phases:

Ø Functions of the programming settings phase

Ø Functions of the programming execution phase.

Ø The functions of the programming settings phase are used for entering or selecting all the job data required for flash programming.

Ø The functions of the programming execution phase are used for flash programming one or more control units.

Whether or not you can switching function phase depends on the scope of the job data you have entered.

Function phase | Functions | Entries required for switching to the level
Programming settings phase | · Entering a ZUSB number · Choosing a ZUSB number · Updating an assembly identification · Entering a VIN · Finishing the programming settings phase | No entries
Programming execution phase | · Programming a ZUSB number · Programming a ZUSB update · Special · Diagnosis | Integration position(s) for a ZUSB number or a control unit family

Table: Function phases of Comfort mode


Functions of the Programming Settings Phase in Comfort Mode

The following functions are available in the programming settings phase of Comfort mode:

· Entering a ZUSB number

· Choosing a ZUSB number

· Updating an assembly identification

· Entering a vehicle identification number

· Finishing the input of job data.

Fig.: Functions of the programming settings phase in Comfort mode


Function: Entering a ZUSB Number

You start the function for entering a ZUSB number either by clicking the "Enter ZUSB" button or by pressing function key <F1> on the keyboard.

When you activate this function, a dialog box opens in which you enter the assembly identification number (ZUSB number).

Fig.: Dialog box for entering a ZUSB number in Comfort mode

Note!

The ZUSB number must consist of 7 digits and solely of numbers otherwise an error message appears which you have to acknowledge.

· If you click "Cancel", your entry is discarded.

· If you click "OK", WinKFPT checks whether the ZUSB number you have entered is present in an <EcuFam>.DAT file of the existing assembly line data sets in the \<root>\DATA directory.

If the assembly identification number you have entered is not found or is invalid, input of the ZUSB number is aborted and the following error message displayed:

Fig.: Error message - ZUSB number not present in the logistics

If the assembly identification number entered is valid, a dialog window appears enabling you to choose one or more integration positions:

Fig. 7‑4: Dialog window for choosing an ECU family, assembly identification number and integration position

The assembly identification number entered and the name of the ECU family associated with it are already highlighted in the window. All you have to do is select one or more ECU addresses by means of their integration position(s) (see also " Function: Selecting a ZUSB numberIDH_funktion_auswahl_einer_zb_nummer ").

Select one, several or all of the integration positions from the "Integration position" list in line with the standard Windows conventions.

· If you click "Cancel", the ZB number entered and integration position selected are discarded.

· If you click "OK", the ZB number is adopted and displayed together with the corresponding hardware number as status information.


Function: Selecting a ZUSB number

You start the function for selecting a ZUSB number either by clicking the "Choose ZUSB" button or by pressing function key <F2> on the keyboard.

When you activate this function, a dialog box opens in which you select an ECU family, assembly identification number and integration position(s) (see “Fig.: Dialog window for choosing an ECU family, assembly identification number and integration position IDH_funktion_eingabe_einer_zb_nummer”).

This dialog box contains three lists:

· " ECU family "

- which contains a list of ECU families or assembly line data sets that exist

· "ZB-Number"

- which contains the assembly identification numbers that belong to the ECU family selected

· " Integration position "

- which contains the integration positions that belong to the ECU family selected, through whose selection the ECU address is specified. Control units that can be installed more than once in the same car are distinguished between only by means of their ECU address or integration position.

The "ECU family" list contains only those ECU families for which the logistics file <ecufam>.DAT, containing at least one ZB number, is present in the respective directories \<root>IDH_footnote_root\data\<ecufam>.

The "ZB Number" list contains all the assembly identification numbers present in the <ecufam>.DAT file that belong to the ECU family selected.

The "Integration position" list contains all the integration positions present in the \<root>IDH_footnote_root\data\gdaten\INFO.ENG file that belong to the ECU family selected.

Select one, several or all of the integration positions from the "Integration position" list in line with the standard Windows conventions.

· If you click "Cancel", the ZB number and integration position selected are discarded.

· If you click "OK", the ZB number is adopted and displayed together with the corresponding hardware number as status information.


Function: Updating an Assembly Identification

You start the function for updating an assembly identification either by clicking the "Update ZUSB" button or by pressing function key <F3> on the keyboard.

When you activate this function, a dialog box opens in which you select an ECU family and integration position(s).

Fig.: Dialog box for updating an assembly identification

This dialog box contains two lists:

· " ECU family "

- which contains a list of ECU families or assembly line data sets that exist

· " Integration position "

- which contains the integration positions that belong to the ECU family selected, through whose selection the ECU address is specified. Control units that can be installed more than once in the same car are distinguished between only by means of their ECU address or integration position.

The "ECU family" list contains only those ECU families for which the logistics file <ecufam>.DAT, containing at least one ZB number, is present in the respective directories \<root>IDH_footnote_root\data\<ecufam>

The "Integration position" list contains all the integration positions present in the \<root>IDH_footnote_root\data\gdaten\INFO.ENG file that belong to the ECU family selected.

Select one, several or all of the integration positions from the "Integration position" list in line with the standard Windows conventions.

· If you click "Cancel", the ECU family and integration position selected are discarded.

· If you click "OK", the selection is adopted and the corresponding pieces of status information (description files, ECU address and diagnosis protocol) displayed.


Function: Entering a Vehicle Identification Number

You start the function for entering a vehicle identification number either by clicking the "Enter VIN" button or by pressing function key <F4> on the keyboard.

This function button is only displayed if KOMFORT_MIT_AIF=ON is set in the configuration file WINKFPT.INI

When you activate this function, a dialog box opens in which you enter the vehicle identification number.

Fig.: Dialog box for entering the vehicle identification number

Note!

The vehicle identification number must consist of 7 or 17 alphanumeric characters otherwise the following error message appears which you have to acknowledge.

Fig.: Error message displayed when an incorrect vehicle identification number is entered

· If you click "Cancel", the vehicle identification number entered is discarded.

· If you click "OK", the vehicle identification number is adopted and displayed as status information.

Note:

With respect to the functions "Enter ZUSB" and "Choose ZUSB", entry of a vehicle identification number is mandatory if KOMFORT_MIT_AIF=ON is set in WINKFPT.INI

Flash programming of the control unit is otherwise not possible in this case.

With respect to the function "Update ZUSB", it is not necessary to enter a vehicle identification number by means of the "Enter VIN" function because in this case the vehicle identification number from the last UIF entry read out beforehand is used for the new UIF entry.

If you nevertheless enter a vehicle identification number by means of "Enter VIN", this number is entered in the new UIF.


Function: Done (Comfort Mode)

The "Done" function completes and ends input and selection of the job data in the programming settings phase of Comfort mode.

You start the function either by clicking the "Done" button or by pressing function key <F8> on the keyboard.

Activating this function leads to a switch of function phase:

· If no entries have been made, the program switches to the function start menu (see Fig.: Function start menu of WinKFPT IDH_funktionsstartmenue_bedienermodi_des_winkfpt).

· If you have entered valid job data by means of "Enter ZUSB" or "Choose ZUSB", the program switches to the "Program" function in the function menu of the programming execution phase of Comfort mode.

Note:

If, with KOMFORT_MIT_AIF=ON set in the configuration file WINKFPT.INI, no vehicle identification number is entered, it is not possible to flash program the control unit, and only the general functions are displayed following switching of the function phase (see (Fig. 9-1: Function menu with the function buttons "Special" and "Diagnosis"IDH_allgemeine_funktionen).

· If you have entered valid job data by means of "Update ZUSB", the program switches to the "Prog. ZB-Update" function in the function menu of the programming execution phase of Comfort mode.


Functions of the Programming Execution Phase in Comfort Mode

The following status information is displayed when the switch is made to the programming execution phase of Comfort mode:

· "ECU address/Integration position"

· "Vehicle identification number IDH_footnote_fgnr_komfort_mit_aif"

· "Assembly identification number"

· "Hardware number"

· "HW interface"

· "Diagnosis protocol"

· "PABD"

· "P-SGBD"

The following functions are available in the programming execution phase of Comfort mode:

· ECU flash programming (depends on the job data)

· ECU flash programming update (depends on the job data)

· Calling of general functions (Special, Diagnosis)

· Ending of the programming execution phase of Comfort mode by switching to the programming settings phase of Comfort mode or oder Expert Mode IDH_experten_modus.

Fig.: Programming execution phase in Comfort mode


Function: Flash Programming

A control unit is flashed by activating the "Program" function.

The function button is activated only after successful input of the ZUSB number by means of the "Enter ZUSB" or "Choose ZUSB" function and/or of the vehicle identification number (with KOMFORT_MIT_AIF=ON set in WINKFPT.INI) in the programming settings phase of Comfort mode, too.

You start the function either by clicking the "Program" button or by pressing function key <F3> on the keyboard.

This function button/key starts flash programming of one or more control units in Comfort mode.

If KOMFORT_MIT_AIF=ON is set in configuration file WINKFPT.INI, the following prompt appears before ECU flash programming starts:

Fig. : Indication of the number of times the UIF can be programmed

Note:

The number of times the UIF can be programmed is taken from the PABD.

· If you click "Cancel", programming is aborted.

· If you click "OK", programming is started.

Fig.: ECU flash programming in Comfort mode

The status of the programming procedure is indicated by a progress bar (0 - 100 %) and as a percentage display in the blue menu status line.

If the configuration entry "ANZEIGE_U_PROG" has been set to ON in WINKFPT.INI, "Programming voltage" is displayed in the top right-hand corner.

At the end of the ECU flash programming procedure, the message <<Programming OK>> appears:

Fig.: Message displayed when ECU programming has been successful

The user info field is not programmed only if the "KOMFORT_MIT_AIF" switch in the WINKFPT.INI file is explicitly set to OFF.

In the event of multiple selection of control units, the job data for the next programming procedure is displayed automatically after each programming procedure, and programming is started again by clicking the "Program" function button (or pressing <F3>).

This means it is possible to abort or to change settings (e.g. HW interface or diagnosis protocol) at any time between the individual programming procedures. At the end of the multiple programming procedure, the message <<Multiple programming finished>> appears:

Fig.: Message displayed when multiple programming has been successful


Function: Programming Update

A control unit is flashed to the latest assembly identification by activating "Prog. ZB-Update".

The function button is activated only following successful input of the job data by means of the "Update ZUSB" function in the programming settings phase of Comfort mode.

You start the function either by clicking the "Prog. ZB-Update" button or by pressing function key <F3> on the keyboard.

This function button starts updating of a control unit to the latest assembly identification. Updating to an incompatible hardware release by means of BSU (boot sector update) is also borne in mind.

For this purpose, the vehicle identification number and the assembly identification number are read out of the last UIF entry in the control unit.

In addition to this assembly identification number, the latest (current) assembly identification number is read from the file \<root>IDH_footnote_root\data\<ecufam>\<ecufam>.his his (= ZUSB history). A switch to a different ECU family and therefore to a new, corresponding ZUSB history is possible.

These two assembly identification numbers are displayed in a dialog box that has to be acknowledged:

Fig. : Dialog box displaying the ZB number from the ECU and the current ZB number

· If you click "No", programming to the latest assembly identification number is aborted.

· If you click "Yes", programming (updating) to the latest assembly identification number is started.

If KOMFORT_MIT_AIF=ON is set in configuration file WINKFPT.INI, the following prompt appears before ECU flash programming starts:

Fig.: Indication of the number of times the UIF can be programmed

Note:

The number of times the UIF can be programmed is taken from the PABD.

· If you click "Cancel", programming is aborted.

· If you click "OK", programming is started.

The status of the programming procedure is indicated by a progress bar (0 - 100 %) and as a percentage display in the blue menu status line.

“Fig.: IDH_funktion_programmieren”).

If the configuration entry "ANZEIGE_U_PROG" has been set to ON in WINKFPT.INI, "Programming voltage" is displayed in the top right-hand corner.

At the end of the ZUSB update programming procedure, the message <<ZUSB-Update programming OK>> appears:

Fig.: Message displayed when ZUSB update programming has been successful

The user info field is not programmed only if the "KOMFORT_MIT_AIF" switch in the WINKFPT.INI file is explicitly set to OFF.

In the event of multiple selection of control units, the job data for the next programming procedure is displayed automatically after each programming procedure, and programming is started again by clicking the "Prog. ZB-Update" function button (or pressing <F3>).

This means it is possible to abort or to change settings (e.g. HW interface or diagnosis protocol) at any time between the individual programming procedures.

At the end of the multiple programming procedure, the message <<Multiple ZUSB-Update programming finished>> appears:

Fig.: Message displayed when multiple ZUSB update programming has been successful


Function Phases in Expert Mode

The functions of Expert mode are divided into three phases:

Ø Functions of programming settings phase Level 1

Ø Functions of programming settings phase Level 2

Ø Functions of the programming execution phase.

Ø The functions of programming settings phase Level 1 are used to select the description files.

Ø The functions of programming settings phase Level 2 are used to enter the ECU address and select data set files.

Ø The functions of the programming execution phase are used for flash programming a program data set or data data set.

Whether or not you can switching function phase depends on the scope of the job data you have entered.

Function phase | Functions | Entries required for switching to the level
Programming settings phase Level 1 | · Loading a PABD · Loading a P-SGBD · Ending the function phase | No entries, just PABD, just P-SGBD
Programming settings phase Level 2 | · Entering an ECU address · Loading a data set – NAAB file · Loading a data set – program file · Loading a data set – data file · Ending the function phase | Both description files PABD and P-SGBD
Programming execution phase | · Programming a NAAB data set · Programming a program data set · Programming a data data set · Special · Diagnosis | Description files (PABD and P-SGBD), data set files (for Program and/or Data), <ECU address>

Table: Function phases of Expert mode


Functions of Programming Settings Phase Level 1 in Expert Mode

The following functions are available in programming settings phase Level 1 of Expert mode:

· Loading a PABD

· Loading a P-SGBD

· Ending programming settings phase Level 1.

Fig.: Functions of programming settings phase Level 1 in Expert mode


Function: Loading a PABD

You start the function for selecting a PABD either by clicking the "PABD" button or by pressing function key <F1> on the keyboard.

When you activate this function, a dialog box opens in which you select a PABD.

Fig.: Dialog box for selecting a PABD

The source code of the flash sequence description files (PABDs) is available in the INPA script language.

For processing in WinKFPT, files can be available in source code or in compiled form; the compiled form is generated from the source code by means of the CABI compiler.

Since the functionality of the CABI compiler is integrated in the COAPI, WinKFPT can process both forms of a PABD.

The criterion by which source code and the compiled form can be distinguished is the extension of the PABD file name, e.g.:

· 17EK924.IPS à PABD in source code

· 17EK924.IPO à PABD in compiled form.

This dialog box displays either all the files in the <root>IDH_footnote_root\SGDAT directory that have the extension IPS or the extension IPO.

This depends on the CabdFormat configuration set in WINKFPT.INI and COAPI.INI (see “ Configuration in COAPI.INI IDH_konfiguration_in_coapi_ini”, “ Configuration in WINKFPT.INI IDH_konfiguration_in_winkfpt_ini”).

· If you click "Cancel", selection of a PABD is aborted. The PABD selected beforehand remains selected.

· If you click "OK", the PABD is adopted and "PABD" is displayed as status information.

After you have selected a PABD, WinKFPT automatically checks whether a P-SGBD has already been selected and is displayed as status information.

Ø P-SGBD not selected: the function menu for programming settings phase Level 1 remains active.

Ø P-SGBD selected: the program switches to the function menu for programming settings phase Level 2.

By selecting a PABD and P-SGBD, you implicitly select a control unit and the program checks whether the control unit supports more than one diagnosis protocol.

If this is the case, the menu option "Diagnosis protocol" is activated and the default diagnosis protocol is displayed as status information (see “ Selecting (Choosing) a Diagnosis Protocol IDH_auswahl_diagnoseprotokoll”).


Function: Loading a P-SGBD

You start the function for selecting a P-SGBD either by clicking the "P-SGBD" button or by pressing function key <F2> on the keyboard.

When you activate this function, a dialog box opens in which you select a P-SGBD.

Fig.: Dialog box for selecting a P-SGBD

This dialog box displays all the files in the <ediabas>IDH_footnote_ediabas\ECU\ directory with the extension PRG.

· If you click "Cancel", selection of a P-SGBD is aborted. The P-SGBD selected beforehand remains selected.

· If you click "OK", the P-SGBD is adopted and "P-SGBD" is displayed as status information.

After you have selected a P-SGBD, WinKFPT automatically checks whether a PABD has already been selected and is displayed as status information.

Ø PABD not selected: the function menu for programming settings phase Level 1 remains active.

Ø PABD selected: the program switches to the function menu for programming settings phase Level 2.

By selecting a PABD and P-SGBD, you implicitly select a control unit and the program checks whether the control unit supports more than one diagnosis protocol.

If this is the case, the menu option "Diagnosis protocol" is activated and the default diagnosis protocol is displayed as status information (see “ Selecting (Choosing) a Diagnosis Protocol IDH_auswahl_diagnoseprotokoll”).


Functions of Programming Settings Phase Level 2 in Expert Mode

The following functions are available in programming settings phase Level 2 of Expert mode:

· Loading an ECU address

· Loading a data set – Data file

· Loading a data set – Program file

· Loading a data set – NAAB file

· Ending programming settings phase Level 2.

Fig.: Programming settings phase Level 2 in Expert mode


Function: Loading an ECU address

You start the function for entering an ECU address either by clicking the "ECU Address" button or by pressing function key <F3> on the keyboard.

When you activate this function, a dialog box opens in which you enter an ECU address.

Fig.: Dialog box for an ECU address

Note!

The ECU address must consist of 2 digits and be hexadecimal otherwise an error message appears which you have to acknowledge and the dialog box is closed.

· If you click "Cancel", input of an ECU address is aborted and the ECU address entered beforehand remains entered.

· If you click "OK", input of the ECU address is completed.

This involves the program calling a P-SGBD job in order to set the ECU address globally.

If this job is present in the P-SGBD, the ECU address you have entered is displayed as status information under "ECU address/integration position".

This, however, does not guarantee that the ECU can be addressed via this address because there is so far no communication with the control unit for this job.

A control unit that is addressed using an incorrect address does not answer and an error message to this effect is displayed.

If the P-SGBD does not contain a job for setting the ECU address, the address is fixed in the P-SGBD and is the text "P-SGBD using internal address" is displayed as status information under "ECU address/integration position".


Function: Loading a Data Set – NAAB File

NAAB:

Boot update description file. This is a data file that is flashed to the program area of an ECU and contains the program for boot sector update and the boot sector itself. The program executes the boot sector update immediately following an ECU reset.

You start the function for selecting a NAAB data set either by clicking the "NAAB file" button or by pressing function key <F6> on the keyboard.

When you activate this function, a dialog box opens in which you select a NAAB data set:

Fig.: Dialog box for selecting a NAAB data set

This dialog box displays all the files in the \<root>IDH_footnote_root\data\develop directory with the extensions 0BA and BAF.

· If you click "Cancel", selection of a NAAB data set is aborted and the NAAB data set selected beforehand remains entered.

· If you click "OK", selection of a NAAB data set is completed and displayed as status information in "NAAB file".

Once the NAAB data set has been selected, the UIF is read.

The following error situations are possible:

· No ECU address has been entered:

If the description files selected require input of an ECU address (external address), an error message to this effect is displayed (see “Fig.: Error message if no ECU address has been entered in Expert mode IDH_funktion_fertig_im_experten_modus”).

The data set remains selected. It is not possible to switch to the programming execution phase of Expert mode unless you have entered an ECU address.

· ECU address entered is wrong:

The control unit can not answer and an error message to this effect is displayed.

It is possible to switch to the programming execution phase of Expert mode.

· Control unit is not connected or does not answer:

The control unit does not answer and an error message to this effect is displayed.


Function: Loading a Data Set – Program File

You start the function for selecting a program data set either by clicking the "Program file" button or by pressing function key <F5> on the keyboard.

When you activate this function, a dialog box opens in which you select a program data set:

Fig.: Dialog box for selecting a program data set

This dialog box displays all the files in the \<root>IDH_footnote_root\data\develop directory with the extensions 0PA and PAF.

· If you click "Cancel", selection of a program data set is aborted and the program data set selected beforehand remains entered.

· If you click "OK", selection of a program data set is completed and displayed as status information in "Program file".

Once the program data set has been selected, WinKFPT checks whether the data set matches the control unit.

To this end, the hardware reference is read out of the control unit and compared with the reference of the data set (keyword: $REFERENZ).

The following error situations are possible:

· No ECU address has been entered:

If the description files selected require input of an ECU address (external address), an error message to this effect is displayed (see “Fig.: Error message if no ECU address has been entered in Expert mode IDH_funktion_fertig_im_experten_modus”).

The data set remains selected. It is not possible to switch to the programming execution phase of Expert mode unless you have entered an ECU address.

· ECU address entered is wrong:

The control unit can not answer and an error message to this effect is displayed.

Note:

Since the data set remains selected and consequently does not have to be reselected once the ECU address has been corrected, you should select the data set once again so that comparison of the references is not unintentionally suppressed.

It is possible to switch to the programming execution phase of Expert mode.

· Control unit is not connected or does not answer:

The control unit does not answer and an error message to this effect is displayed.

Note:

Since the data set remains selected and consequently does not have to be reselected once the control unit has been properly connected, you should select the data set once again so that comparison of the references is not unintentionally suppressed.

· Hardware reference from the ECU and reference from the data set do not match up:

The following error message is displayed:

Fig.: Error message if references in ECU and program data set do not match up

This error message indicates the data set reference after "DS:" and the control unit reference after "ECU:".

It is possible to switch to the programming execution phase of Expert mode.

It is possible to switch to the programming execution phase of Expert mode.

N.B.:

The control unit may be unusable following programming and have to be submitted for recycling.


Function: Loading a Data Set – Data File

You start the function for selecting a data data set either by clicking the "Data file" button or by pressing function key <F4> on the keyboard.

When you activate this function, a dialog box opens in which you select a data data set (characteristic-diagram data):

Fig. 8‑9: Dialog box for selecting a data data set

This dialog box displays all the files in the \<root>IDH_footnote_root\data\develop directory with the extensions 0DA and DAF.

· If you click "Cancel", selection of a data data set is aborted and the data data set selected beforehand remains entered.

· If you click "OK", selection of a data data set is completed and displayed as status information in "Data file".

Once the data data set has been selected, WinKFPT checks whether the data set matches the control unit.

To this end, the data reference is read out of the control unit and compared with the reference of the data set (keyword: $REFERENZ).

The following error situations are possible:

· No ECU address has been entered:

If the description files selected require input of an ECU address (external address), an error message to this effect is displayed (see "Fig. : Error message if no ECU address has been entered in Expert mode").

The data set remains selected. It is not possible to switch to the programming execution phase of Expert mode unless you have entered an ECU address.

· ECU address entered is wrong:

The control unit can not answer and an error message to this effect is displayed.

Note:

Since the data set remains selected and consequently does not have to be reselected once the ECU address has been corrected, you should select the data set once again so that comparison of the references is not unintentionally suppressed.

It is possible to switch to the programming execution phase of Expert mode.

· Control unit is not connected or does not answer

The control unit does not answer and an error message to this effect is displayed.

Note:

Since the data set remains selected and consequently does not have to be reselected once the control unit has been properly connected, you should select the data set once again so that comparison of the references is not unintentionally suppressed.

It is possible to switch to the programming execution phase of Expert mode.

· Data reference from the ECU and reference from the data set do not match up:

The following error message is displayed:

Fig. : Error message if references in ECU and data data set do not match up

This error message indicates the data set reference after "DS:" and the control unit reference after "ECU:".

It is possible to switch to the programming execution phase of Expert mode.

The data data set can be programmed even if the references do not match up.

N.B.:

The control unit may be unusable following programming and have to be submitted for recycling.


Function: Done (Expert Mode)

The "Done" function completes and ends input and selection of the job data in programming settings phase Levels 1 and 2 of Expert mode.

You start the function either by clicking the "Done" button or by pressing function key <F8> on the keyboard.

Activating this function leads to a switch of function phase:

· If no entries have been made, the program switches to the function start menu (see Fig. Function start menu of WinKFPT IDH_funktionsstartmenue_bedienermodi_des_winkfpt).

· If only a PABD has been selected, the program switches to the function start menu.

· If only a P-SGBD has been selected, the program switches to the function start menu.

· If a PABD and P-SGBD have been selected, the program checks whether an ECU address has to be entered.

If an ECU address is not required, the text "P-SGBD using internal address" is displayed as status information under "ECU address/integration position".

If an ECU address is required and one has not been entered, the following error message is displayed:

Fig. : Error message if no ECU address has been entered in Expert mode

When you acknowledge the error message, the program switches to the function start menu.

PABD and P-SGBD remain selected and you can now enter the ECU address.

· If a PABD, P-SGBD and ECU address have been selected, only the general functions are made available for use (see “ General Functions IDH_allgemeine_funktionen”).

· If a PABD, P-SGBD, ECU address and a data set for program and/or data have been selected, the program switches to the function menu of the programming execution phase of Expert mode.


Functions of the Programming Execution Phase in Expert Mode

The following status information is displayed when the switch is made to the programming execution phase of Expert mode:

· "ECU address"

· "Vehicle identification number IDH_footnote_fgnr_expert_mit_aif"

· "HW interface"

· "Diagnosis protocol"

· "Data file"

· "Program file"

· "NAAB file"

· "PABD"

· "P-SGBD"

The following functions are available in the programming execution phase of Expert mode:

· NAAB programming (BSU) (depends on the job data)

· Program programming (depends on the job data)

· Data programming (depends on the job data)

· Calling of general functions (Special, Diagnosis)

· Ending of the programming execution phase of Expert mode by switching to the programming settings phase of Comfort mode or Expert mode.

Fig. : Programming execution phase in Expert mode


Function: Programming a NAAB Data Set

You start the function for programming a NAAB data set either by clicking the "Prog. NAAB" button or by pressing function key <F3> on the keyboard.

The function button is activated only following successful selection of an NAAB data set file by means of the "NAAB file" function in programming settings phase Level 2 of Expert mode.

The status of the programming procedure is indicated by a progress bar (0 - 100 %) and as a percentage display in the blue menu status line.

If the configuration entry "ANZEIGE_U_PROG" has been set to ON in WINKFPT.INI, "Programming voltage is displayed in the top right-hand corner.

At the end of the ECU flash programming procedure and exchange of the boot sector, the message <<Bootsektorupdate OK>> appears:

Fig.: Message displayed following successful ECU flashing programming in Expert mode


Function: Programming a Program Data Set

You start the function for programming a program data set either by clicking the "Prog. Program" button or by pressing function key <F3> on the keyboard.

The function button is activated only following successful selection of a program data set file by means of the "Program file" function in programming settings phase Level 2 of Expert mode.

Note:

The user info field is programmed only if the configuration settings EXPERT_MIT_AIF and AIF_SCHREIBEN_NACH_PROGRAMM in WINKFPT.INI are set to ON.

Note:

If a UIF is to be programmed, the dialog box for entering the vehicle identification number appears (see “7.1.4 Function: Entering a Vehicle Identification Number IDH_funktion_eingabe_einer_fahrgestellnummer”).

Without a vehicle identification number, programming is not possible in this case.

The following prompt appears once you have entered the vehicle identification number:

Fig.: Indication of the number of times the UIF can be programmed

Note:

The number of times the UIF can be programmed is taken from the PABD.

The status of the programming procedure is indicated by a progress bar (0 - 100 %).

If the configuration entry "ANZEIGE_U_PROG" has been set to ON in WINKFPT.INI, "Programming voltage" is displayed in the top right-hand corner.

Fig. : ECU flash programming in Expert mode

At the end of the ECU flash programming procedure, the message <<Programming OK>> appears:

Fig.: Message displayed following successful ECU flashing programming in Expert mode


Function: Programming a Data Data Set

You start the function for programming a data data set either by clicking the "Prog. Data" button or by pressing function key <F5> on the keyboard.

The function button is activated only following successful selection of a data data set file by means of the "Data file" function in programming settings phase Level 2 of Expert mode.

Note:

The user info field is programmed only if the configuration settings EXPERT_MIT_AIF and AIF_SCHREIBEN_NACH_DATEN in WINKFPT.INI are set to ON.

Note:

If a UIF is to be programmed, the dialog box for entering the vehicle identification number appears (see “7.1.4 Function: Entering a Vehicle Identification Number IDH_funktion_eingabe_einer_fahrgestellnummer”).

Without a vehicle identification number, programming is not possible in this case.

The following prompt appears once you have entered the vehicle identification number:

Fig. :Indication of the number of times the UIF can be programmed

Note:

The number of times the UIF can be programmed is taken from the PABD.

The status of the programming procedure is indicated by a progress bar (0 - 100 %) (see "Fig. : ECU flash programming in Expert modeIDH_funktion_programm_programmieren ").

If the configuration entry "ANZEIGE_U_PROG" has been set to ON in WINKFPT.INI, "Programming voltage" is displayed in the top right-hand corner.

At the end of the ECU flash programming procedure, the message <<Programming OK>> appears (see “Fig.: ECU flash programming in Expert mode IDH_funktion_programm_programmieren”).

If the configuration entry "ANZEIGE_U_PROG" has been set to ON in WINKFPT.INI, "Programming voltage" is displayed in the top right-hand corner.

At the end of the ECU flash programming procedure, the message <<Programming OK>> appears


General Functions

The general functions of WinKFPT are divided up into the following groups:

· Special Functions

· Diagnosis Functions

You select a group by clicking one of the following function buttons or pressing the corresponding function key on the keyboard:

· "Special"

· "Diagnosis"

Fig.: Function menu with the function buttons "Special" and "Diagnosis"

Since calling a general function always involves communicating with an ECU, a minimum amount of job data must have been entered in the active operating mode of WinKFPT.

The function buttons for the general functions are only displayed:

· once programming settings phase Level 1 or 2 of Expert mode has been completed and at least one PABD, P-SGBD and ECU address (ECU address only if the P-SGBD uses an external address) have been selected/entered (see “ Functions of Programming Settings Phase Level 1 in Expert Mode IDH_funktionen_der_programmiereinstellungsebene_stufe_1_im_experten_modus” and “ Functions of Programming Settings Phase Level 2 in Expert Mode IDH_funktionen_der_programmiereinstellungebene_stufe_2_im_experten_modus”).

· once the programming settings phase of Comfort mode has been completed and a ZUSB number and ECU address/integration position have been selected/entered by means of one of the following functions: "Enter ZUSB", "Choose ZUSB" or "Update ZUSB" (see “7.1 Functions of the Programming Settings Phase in Comfort Mode IDH_funktionen_der_programmiereinstellungebene_im_komfort_modus”).


Special Functions

When you click the "Special" function button (or press <F3>) in Expert or Comfort mode, the function menu with the function buttons for calling the special functions of WinKFPT is opened:

Fig.: Function menu for the special functions

This function menu contains buttons for activating the following functions:

· Reading the UIF

· Reading the ECU baudrates

· Reading and writing the calibration values

· VS20/DS2 Mode

· EWS alignment

· Exiting the Special function menu


Function: Reading the UIF

You start the function for displaying the UIF entries of a control unit either by clicking the "Read UIF" button in the Special function menu or by pressing function key <F1> on the keyboard.

When you activate this function, all the user info field (UIF) entries of the control unit are read out and displayed by the following PABD job:

· SG_AIF_LESEN

Prerequisite for this is a valid UIF entry in the control unit.

The contents of the UIF display dialog are written to the file AIF_<Interface>_<Unit>.OUT in the \<root>IDH_footnote_root\BIN directory.

The contents of the AIF_<Interface>_<Unit>.OUT file are overwritten every time "Read UIF" is activated.

The file name is displayed in the header of the UIF display dialog.

Fig.: Display dialog for the Special function "Read UIF"

You close the UIF display dialog by clicking "OK".


Function: Reading the ECU Baudrates

You start the function for displaying the ECU baudrates of a control unit either by clicking the "ECU baudrates" button in the Special function menu or by pressing function key <F2> on the keyboard.

When you activate this function, all the possible baudrates of the control unit are read out and displayed by the following PABD job:

· BAUDRATE_LESEN

The contents of the ECU baudrates display dialog are written to the file BD_<Interface>_<Unit>.OUT in the \<root>IDH_footnote_root\BIN directory.

The contents of the BD_<Interface>_<Unit>.OUT file are overwritten every time "ECU baudrates" is activated.

This functionality is no longer supported by standard PABD jobs.

If you call "ECU baudrates" for control units with standard description files, the following error message appears:

Fig.: Error message displayed when you call "ECU baudrates"


Function: Reading and Writing the Calibration Values

You start the function for reading and writing the calibration values of a control unit either by clicking the "Calibration values" button in the Special function menu or by pressing function key <F3> on the keyboard.

When you activate this function, the submenu for reading and writing the calibration values of the control unit opens.

Fig.: Submenu for reading and writing the calibration values

This function enables you to read specific data (calibration values) out of a control unit and write it to another control unit.

Procedure for transferring calibration values:

· Connect the control unit from which the calibration values are to be read.

· Click the "Read Calib." button or press <F1> on the keyboard.

The calibration values are read out of the ECU and buffered in a temporary file.

The "Write Calib." function button is now active.

· Connect the control unit to which the calibration values are to be written.

· If necessary, select the HW interface and diagnosis protocol for the second control unit.

· Click the "Write Calib." button.

The calibration values are read out of the temporary file and written to the ECU.

A message confirming that the data has been successfully transferred is then displayed.

You close the submenu for calibration values either by clicking the "Done" button

or by pressing function key <F8> on the keyboard.

The submenu for calibration values is closed and the Special function menu is displayed again.


Function: VS20/DS2 Mode

You start the function for selecting VS20/DS2 mode either by clicking the "VS20/DS2-Mode" button in the Special function menu or by pressing function key <F4> on the keyboard.

When you activate this function, WinKFPT switches to the submenu for VS20/DS2 mode.

By activating "VS20 Mode" or "DS2 Mode" from this submenu, the control unit connected can be switched to VS20 or DS2 mode by means of the PABD job VS20_MODE or D2 MODE.

This functionality is no longer supported by standard PABD jobs.

If you call "VS20 Mode" or "DS2 Mode" for control units with standard description files, the following error message appears:

Fig.: Error message displayed when you call "VS20 Mode" or "DS2 Mode"


Function: EWS Alignment

You start the function for EWS alignment either by clicking the "EWS Alignment" button in the Special function menu or by pressing function key <F5> on the keyboard.

This functionality is no longer supported.

When you call "EWS Alignment", the following message appears:

Fig.: Message displayed when you call "EWS Alignment"


Function: Done

You close the Special function menu either by clicking the "Done" button in the Special function menu

or by pressing function key <F8> on the keyboard.

When you activate this function, the Special function menu is closed and WinKFPT switches back to the main menu or to the function phase of the operating mode from which the Special function menu was started.


Function: HDDownload

You start the function for HDDownload by clicking the "HDDownload" button in the Special function menu.

The button “HDDownload” is available, when a PABD and a SGBD, which both support HDDownload, were selected in Expert mode.


Function: HDD-Test

You start the function for HDD-Test by clicking the "HDD-Test" button in the Special function menu.

The button “HDD-Test” is available, when a PABD and a SGBD, which both support HDDownload, were selected in Expert mode.


Diagnosis Functions

1.1 Diagnosis Functions

When you click the "Diagnosis" function button (or press <F4>) in Expert or Comfort mode, the function menu with the function buttons for calling the diagnosis functions of WinKFPT is opened:

Fig.: Menu for the diagnosis functions

This menu contains buttons for activating the following functions:

· Displaying the ECU status

· Reading the ECU identification

· Reading the ECU internal temperature

· Exiting the Diagnosis menu


Function: Displaying the ECU Status

You start the function for displaying the ECU status of a control unit either by clicking the "ECU Status" button in the Diagnosis function menu or by pressing function key <F1> on the keyboard.

When you activate this function, the following data is read out of the control unit and displayed:

· Data reference

· Hardware reference

· Supplier info field (ZIF)

· Backup of the supplier info field

· Programming status (ECU status)

The data is read out of the control unit by the following PABD jobs:

· DATEN_REFERENZ

· HW_REFERENZ

· ZIF

· ZIF_BACKUP

· SG_STATUS_LESEN

The contents of the ECU status display dialog are written to the file REF_<Interface>_<Unit>.OUT in the \<root>IDH_footnote_root\BIN directory.

The contents of the REF_<Interface>_<Unit>.OUT file are overwritten every time "ECU Status" is activated.

The file name is displayed in the header of the ECU status display dialog.

Fig.: Display dialog for the ECU status

You close the ECU status display dialog by clicking "OK".


Function: Reading the ECU Identification

You start the function for displaying the identification of a control unit either by clicking the "ECU Ident" button in the Diagnosis function menu or by pressing function key <F2> on the keyboard.

When you activate this function, the identification data of the control unit is read out and displayed by the following PABD jobs:

· SG_IDENT_LESEN

· SG_PHYS_HWNR_LESEN

The contents of the ECU identification display dialog are written to the file IDENT_<Interface>_<Unit>.OUT in the \<root>IDH_footnote_root\BIN directory.

The contents of the IDENT_<Interface>_<Unit>.OUT file are overwritten every time "ECU Ident" is activated.

The file name is displayed in the header of the ECU identification display dialog.

Fig.: Display dialog for the ECU identification

You close the ECU identification display dialog by clicking "OK".


Function: Reading the ECU Internal Temperature

You start the function for displaying the internal temperature of a control unit either by clicking the "ECU intern. Temp" button in the Diagnosis function menu or by pressing function key <F3> on the keyboard.

When you activate this function, the internal temperature of the control unit is read out and displayed.

The following standard PABD job is executed to read the internal temperature out of a control unit:

· SG_INNENTEMP_LESEN

The contents of the ECU internal temperature display dialog are written to the file INNENTMP_<Interface>_<Unit>.OUT in the \<root>IDH_footnote_root\BIN directory.

The contents of the INNENTMP_<Interface>_<Unit>.OUT file are overwritten every time "ECU intern. Temp" is activated.

The file name is displayed in the header of the ECU internal temperature display dialog.

Fig.: Display dialog for the ECU internal temperature

If the control unit does not support this function, the following message is displayed which you have to acknowledge:

<<ECU internal temperature not supported>>

You close the ECU internal temperature display dialog by clicking "OK".


Function: Done

You close the Diagnosis function menu either by clicking the "Done" button in the Diagnosis function menu

or by pressing function key <F8> on the keyboard.

When you activate this function, the Diagnosis function menu is closed and WinKFPT switches back to the main menu or to the function phase of the operating mode from which the Diagnosis function menu was started.


Error Handling in WinKFPT

The process of flash programming an ECU with WinKFPT is very complex and depends on trouble-free interaction of the following components:

· Hardware connection – Test computer Ö Diagnosis HW interface Ö ECU

· Software connection – WinKFPT Ö EDIABAS Ö Diagnose interface driver Ö ECU program

· Configuration of WinKFPT and COAPI

· Description files PABD and P-SGBD

· Logistics files

· Programming data files (PAF, DAF, etc.)

Each component contains a multitude of potential errors that must be trapped by WinKFPT and displayed to the user in a manner that enables him to recognize the cause from the error message displayed and eliminate this cause on his own initiative.

The functions built into WinKFPT can be roughly split into two types: namely, into functions with and without COAPI calls. The manner in which errors that arise while executing these functions differs between the two types.

· Displaying errors in WinKFPT functions without COAPI calls:

Display of informative error, diagnosis and info texts in appropriate message boxes.

The texts are loaded dynamically from the text file "winkfpt.txt". It is possible to improve on the explanatory power/correctness of the texts at any time without making changes to WinKFPT.

· Displaying errors in WinKFPT functions with COAPI calls:

Each time an error occurs when a COAPI function is called, an error dialog is displayed. The top text box in this dialog contains a text that informs you of which active WinKFPT function the error has occurred in. The list box below this contains a detailed list of errors traced through all the COAPI call levels run through.

This error list should not be viewed as a list of different errors, rather as a breakdown of just a single error, with the respective information that has been able to be established from the relevant COAPI call levels.

The COAPI error texts are loaded dynamically from the text file "coapierr.txt".


Displaying Errors

The figure below shows the "Normal view" display of a WinKFPT error associated with a defective COAPI call.

Switching to the "Extended view" is of no benefit to "normal" users. This view is intended merely as an additional debugging aid for WinKFPT or COAPI experts.

Fig.: Error display window in WinKFPT

In the example above, you can see that initialization of the COAPI by WinKFPT has failed.

The list of errors from the respective COAPI call levels clearly shows the user which of the many initialization errors possible is the actual cause of the error.

The first line of the error list displays the error message of the "lowest" COAPI call level and generally contains comprehensive and crucial information for debugging purposes.

In this case, the user must check whether the file "KFCONFXX.DA” is present in the <root>\DATA\gdaten directory, or whether or not he has read rights to it.


Description and Elimination of Frequently Occurring Errors


Errors When Starting WinKFPT

Error | COAPI errors 1020, 3017, WinKFPT error 1
Time of occurrence | · When starting WinKFPT.
Possible cause | · A logistics file is missing in the ../data/gdaten directory. The error dialog tells you which file it is.
Debugging | · Import an up-to-date assembly line data set with description files. · Copy the missing logistics file to the ../data/gdaten directory by hand.

Error | COAPI errors 4211, 4206, 1040, 3017, WinKFPT error 1
Time of occurrence | · When starting WinKFPT.
Possible cause | · The ../data/gdaten directory contains a faulty and therefore unconvertible logistics file. The error dialog (in particular error 4206) tells you which file it is and in which line the error occurred.
Debugging | · Import an up-to-date assembly line data set with correct description files. · Repair the faulty logistics file in the ../data/gdaten directory by hand.

Error

WinKFPT error 300

Time of occurrence

· When starting WinKFPT.

Possible causes

· The interface is already being used by a different program or possibly by a different instance of WinKFPT.

· The default interface is not correctly set up in Ediabas.

Debugging

· Close the other application that is using the interface. (Application may only be able to be seen in the task manager.)

· Use a different application (e.g. TEOF in the Ediabas\bin directory) to check whether the interface actually functions. If not: check Ediabas and/or the interface driver.


Errors When Importing Assembly Line Data

Error | ECU directory is not displayed
Time of occurrence | · When selecting an assembly identification number in Comfort mode.
Possible cause | · Imported ECU directory does not contain any PABD/P-SGBD description files.
Debugging | · Import an assembly line data set with description files.

Error | WinKFPT error 11
Time of occurrence | · When importing a single description file.
Possible causes | · The description file could not be copied. · The file already exists in the target directory and is write-protected. · The file already exists in the target directory and has been opened by an application. · The source file has no read rights. · No write rights in the target directory.
Debugging | Depending on the cause: · Cancel write protection. · Close the application that has opened the file. · Check and adapt the file rights.

Error | WinKFPT error 111
Time of occurrence | · When importing an assembly line data set.
Possible cause | · The assembly line data set does not contain a file of type <EcuFamilyname>.dat
Debugging | · Fetch the correct assembly line data set (e.g. from Darwin).


Errors When Entering Flash Data

Error | COAPI errors 1065, 1000, WinKFPT error 106
Time of occurrence | · When loading the suggested configuration after activating the <Expert mode> button. · In Comfort mode when activating the [Done] button after selecting a ZB number and integration position.
Possible cause | · The PABD from the configuration does not exist.
Debugging | · Copy or import the PABD to the relevant Ediabas directory.

Error | COAPI error 2000, WinKFPT error 106
Time of occurrence | · When loading the suggested configuration after activating the <Expert mode> button. · In Comfort mode when activating the [Done] button after selecting a ZB number and integration position.
Possible cause | · The SGBD from the configuration does not exist.
Debugging | · Copy or import the SGBD to the relevant Ediabas directory.

Error | COAPI error 3000
Time of occurrence | · In Comfort mode after entering a ZB number by hand.
Possible cause | · This is no (correct) DAT file that contains the ZB number.
Debugging | · Import the assembly line data set for the ECU family to which the ZB number belongs.

Error | WinKFPT errors 500 to 503
Time of occurrence | · When selecting the data file in Expert mode. · When selecting the program file in Expert mode.
Possible causes | · The wrong ECU has been connected. The ECU identifier in the data/program file selected does not match up with the identifier of the ECU connected. · The wrong data/program file has been selected.
Debugging | · Determine whether the correct ECU is connected. If necessary, connect the correct ECU. · Determine whether the correct data/program file has been selected. If necessary, select the correct file.

Error | COAPI error 2020
Time of occurrence | · When selecting the data file in Expert mode. · When selecting the program file in Expert mode.
Possible cause | · An incorrect ECU address has been entered: · The control unit is not connected or communication is disrupted.
Debugging | · Enter the correct ECU address. · Connect the ECU. Check whether communication is actually possible.

Error | COAPI error 1020
Time of occurrence | · When activating the [Program] button in Comfort mode.
Possible cause | · An ECU family-specific logistics file (HWH or HIS) is not present. The error dialog tells you which file it is.
Debugging | · Fetch the file by importing the assembly line data · or copy the file to the data directory by hand.

Error | COAPI errors 4209 or 4211, 4206, 1040, 3000
Time of occurrence | · When activating the [Program] button in Comfort mode.
Possible cause | · An ECU family-specific logistics file (DAT, HWH or HIS) is faulty. The error dialog (in particular error 4206) tells you which file it is and in which line the error occurred.
Debugging | · Fetch an intact file by importing the assembly line data · or eliminate the error in the file by hand.

Error | COAPI errors 4204, 1040
Time of occurrence | · When activating the [Program] button in Comfort mode.
Possible cause | · The file to be flashed does not exist. The error dialog (in particular error 4204) tells you which file it is.
Debugging | · Fetch the file by importing the assembly line data · or copy the file to the data directory by hand.

Error | COAPI errors 4220 or 4209, 4221, 1040,
Time of occurrence | · When selecting a program or data file in Expert mode. · When activating the [Program] button in Comfort mode.
Possible cause | · The file to be flashed is faulty. The error dialog (in particular error 4221) tells you which file it is and in which line the error occurred.
Debugging | · Fetch an intact file by importing the assembly line data · or eliminate the error in the file by hand.

Error | WinKFPT error 100
Time of occurrence | · In Expert mode after selecting PABD and SGBD, when activating the [Done] button.
Possible cause | · The SGBD demands an external ECU address.
Debugging | · Enter an ECU address.

Error | WinKFPT error 102 or 103
Time of occurrence | · In Expert mode when entering an ECU address.
Possible cause | · A 2-digit, hexadecimal number has not been entered as the ECU address.
Debugging | · Enter a correct hexadecimal number.

Error | WinKFPT error 107
Time of occurrence | · When entering a vehicle identification number (necessary when UIF write is active).
Possible cause | · The vehicle identification number was either not a 7-digit number or not alphanumeric.
Debugging | · Enter a correct vehicle identification number.

Error | WinKFPT error 108
Time of occurrence | · When entering a ZB number in Comfort mode.
Possible cause | · The ZB number was not a 7-digit number.
Debugging | · Enter a 7-digit ZB number.


Errors During Data Programming

Error | CAPI error 2020 or 2021
Time of occurrence | · When starting programming in both operating modes..
Possible causes | · The ECU is not connected. · The HW interface is not fully installed. · The interface is not connected.
Debugging | · Determine whether the ECU is connected. · Re-install the interface. · Determine whether the interface hardware is connected.

Error | COAPI error 1060
Time of occurrence | · When starting programming by activating the <Prog. Data> button, following input of the PABD, P-SGBD and the program data set in Expert mode.
Possible causes | · The wrong hardware interface has been selected. · The interface is not fully installed. · The interface is not connected. · The ECU is not connected.
Debugging | · Determine whether the correct HW interface is displayed as status information. If necessary, select the correct HW interface under menu option Communication à HW interface. · Re-install the interface. · Determine whether the interface hardware is connected. · Determine whether the ECU is connected.

Error

COAPI error 2064: Delete error in coding data (e.g. ZCS)

Time of occurrence

· When starting programming by activating the <Prog. Data> button.

Possible cause

· The last programming session was not successfully completed and terminated.

Debugging

· The program must be flashed to the ECU again.

To this end, enter PABD, P-SGBD and the program data set in Expert mode. Confirm the entries made in Expert mode by activating the <Done> button.

Start flash programming of the control unit with the program data set by activating the <Prog. Program> button.


Glossary

CABD | Coding sequence description file
CABI | Coding sequence interpreter
COAPI | Coding application interface
Comfort mode | Programming after entering or selecting the job data, assembly identification number and control unit address, and the vehicle identification number if UIF write is activated.
DAF | Flash data image file
Expert mode | Programming after selecting the PABD, P-SGBD, data file and/or program file.
HIS | (Assembly) History file
IFH | Interface handler
INPA | Interpreter for test sequences
Interface | Hardware unit for communication with control units, e.g. EDIC, ADS, MOST
IPO | Extension of a sequence description file in object format
IPS | Extension of a sequence description file in source format
NAAB | Boot update description file. This is a data file that is flashed to the program area of an ECU and contains the program for boot sector update and the boot sector itself.
PABD | Flash sequence description file
PAF | Flash program image file
P-SGBD | Control unit description file for programming.
SGBD | ECU description file
UIF | User info field
Unit | Subunits of interfaces designated _, A, B, C, etc. if several interfaces of one type are installed in the same computer.
WDP | An importable directory that contains all the files of an ECU family required to flash control units from this ECU family with the aid of a BMW programming tool.
ZIF | Supplier info field. The ZIF in the control unit indicates the state of development of the control unit program.
ZUSB number ZB number | Assembly identification number